]> git.pld-linux.org Git - packages/rpm-build-macros.git/blame - rpm.macros
- 1.536
[packages/rpm-build-macros.git] / rpm.macros
CommitLineData
397b586d 1# $Revision$, $Date$
f51bfb2f
ER
2# PLD Linux rpm macros.
3# <http://www.pld-linux.org/>
d54662bf 4
98c5c988
ER
5# can be used by builder script to to check for version
6%rpm_build_macros %(R="$Revision$"; RR="${R##: }"; echo ${RR%%?})
7
e05017c1 8%epoch 0
3241033b 9%x8664 x86_64 amd64 ia32e
9c404149 10
ba1fdedc 11# kernel compiler
345d14e5 12%kgcc %{__cc}
d2e1bc22 13%kgcc_package gcc
ba1fdedc 14
46763914 15# compiler version
69bcfbf3 16%cc_version %{expand:%%global cc_version %(%{__cc} -dumpversion || echo ERROR)}%cc_version
de629430 17%cxx_version %{expand:%%global cxx_version %(%{__cxx} -dumpversion || echo ERROR)}%cxx_version
46763914 18
69bcfbf3 19%__rm /bin/rm --interactive=never
36eccf0d 20
33040789 21# Build system path macros.
69bcfbf3
ER
22%__autoconf autoconf %{?debug:-Wall}
23%__automake automake -a -c -f --foreign
24%__autopoint autopoint --force
25
26# add parallel build flags: -jN
a5656a95 27#
11ecb0a1
ER
28# if you want to disable parallel build do:
29# echo '%_smp_mflags %{nil}' >> ~/.rpmmacros
a5656a95 30#
11ecb0a1
ER
31%__make /usr/bin/make %{?_smp_mflags}
32%__scons /usr/bin/scons %{?_smp_mflags}
33%__waf /usr/bin/waf %{?_smp_mflags}
b8f83d42 34%__cmake /usr/bin/cmake
a5656a95
JR
35
36%_smp_mflags %(_NCPUS=$(/usr/bin/getconf _NPROCESSORS_ONLN); \\\
37 [ "$_NCPUS" -gt 1 ] && echo "-j$(($_NCPUS * 2))")
f93109a0 38
83094b62 39%__gettextize { \
8a995cff 40 if grep -qs 'AM_GNU_GETTEXT.*external' configure.{ac,in} ; then \
3241033b 41 gettextize --copy --force --no-changelog; \
97589b6e 42 else \
3241033b 43 gettextize --copy --force --no-changelog --intl; \
8a995cff
JB
44 fi; \
45 if [ ! -f po/Makevars ]; then \
3241033b 46 cp -f po/Makevars{.template,}; \
8a995cff 47 fi; \
8a995cff 48}
f93109a0 49
50%__glib_gettextize glib-gettextize --copy --force
51%__gnome_doc_common gnome-doc-common --copy
fb59e475 52%__gnome_doc_prepare gnome-doc-prepare --copy --force
f93109a0 53%__gtkdocize gtkdocize --copy
54%__intltoolize intltoolize --copy --force
c26f1b59 55%__libtoolize libtoolize --copy --force --install
33040789 56
1052b4b8
ER
57# topdir is where builder script lives, fallback to old style if builder script was not found and
58# SPECS/SOURCES dirs exist (XXX: should be reverse?)
59%_topdir %{expand:%%global _topdir %(d=;\
60 d=${d:-$([ -d ../SPECS -a -d ../SOURCES ] && (cd .. && pwd))};\
d5617d26
ER
61 d=${d:-$([ -x ../builder -a ! -d ../builder ] && (cd ..; pwd))};\
62 d=${d:-$([ -x builder -a ! -d builder ] && pwd)};\
1052b4b8
ER
63 echo ${d:-$HOME/rpm};\
64)}%_topdir
65
66# if %{_topdir}/builder exists, it's new style structure
67%_specdir %{expand:%%global _specdir %([ -x %{_topdir}/builder ] && echo %{_topdir}/%{name} || echo %{_topdir}/SPECS)}%_specdir
68%_sourcedir %{expand:%%global _sourcedir %([ -x %{_topdir}/builder ] && echo %{_specdir} || echo %{_topdir}/SOURCES)}%_sourcedir
69
70# BUILD/RPMS/SRPMS are one same level by default as packages dir, if these exist
71# if they don't exist assume we are having custom topdir (which is not named as
72# "packages", i.e ~/rpm/kde/{kdelibs,BUILD/RPMS/SRPMS})
73%_builddir %{expand:%%global _builddir %([ -d %{_topdir}/../BUILD ] && (cd %{_topdir}/../BUILD; pwd) || echo %{_topdir}/BUILD)}%_builddir
74%_rpmdir %{expand:%%global _rpmdir %([ -d %{_topdir}/../RPMS ] && (cd %{_topdir}/../RPMS; pwd) || echo %{_topdir}/RPMS)}%_rpmdir
75%_srcrpmdir %{expand:%%global _srcrpmdir %([ -d %{_topdir}/../SRPMS ] && (cd %{_topdir}/../SRPMS; pwd) || echo %{_topdir}/SRPMS)}%_srcrpmdir
384e1b2b 76
81e450f7
ER
77# The number of cvs changelog entries kept when building package.
78%_buildchangelogtruncate 20
79
6a5eda77 80%dependencytracking %{nil}
3241033b 81
e5da9169
ER
82# Relations between package names that cause dependency loops
83# with legacy packages that cannot be fixed. Relations are
84# specified as
85# p>q
86# where package p has a Requires: on something that package q Provides:
87#
88# XXX Note: that there cannot be any whitespace within the string "p>q",
89# and that both p and q are package names (i.e. no version/release).
90%_dependency_whiteout %{nil}
91
810fa5c4 92#-----------------------------------------------------------------
93#
94# (re)definition of %{rpm*flags} with %filterout_* support
b5e977c5
ER
95# BuildRequires: awk
96# BuildRequires: rpmbuild(macros) >= 1.315
810fa5c4 97#
98# Flags specified in %filterout_* are removed from %rpm*flags, exactly:
09a90176 99# %rpmcflags = %optflags - %filterout - %filterout_c - %filterout_ld
100# %rpmcxxflags = %optflags - %filterout - %filterout_cxx - %filterout_ld
98e7f050 101# %rpmcppflags = %optcppflags - %filterout - %filterout_cpp - %filterout_ld
09a90176 102# %rpmldflags = %optldflags - %filterout_ld
810fa5c4 103#
104# Regular expressions are supported, but to avoid some character be treated
105# as regular expression it must be escaped twice.
106
107%filter_out \
7b6f1112 108 for (i = 1; i in I; i++) { A=0; \
810fa5c4 109 for (f in F) { \
110 if (I[i] ~ "^" F[f] "$") A=1; \
111 }; \
112 if (!A) printf(I[i] FS); \
113 }
114
115%rpmcflags %(awk 'BEGIN {
116 split("%{?debug:%debugcflags}%{!?debug:%optflags}%{?debuginfocflags}",I);
09a90176 117 split("%{?filterout} %{?filterout_c} %{?filterout_ld}",F);
810fa5c4 118 %{filter_out}
119}')
120
121%rpmcxxflags %(awk 'BEGIN {
09a90176 122 split("%{?debug:%debugcflags}%{!?debug:%optflags}%{?debuginfocflags}",I);
123 split("%{?filterout} %{?filterout_cxx} %{?filterout_ld}",F);
810fa5c4 124 %{filter_out}
125}')
126
98e7f050
AM
127%rpmcppflags %(awk 'BEGIN {
128 split("%{?debug:%debugcppflags}%{!?debug:%optcppflags}%{?debuginfocppflags}",I);
129 split("%{?filterout} %{?filterout_cpp} %{?filterout_cpp}",F);
130 %{filter_out}
131}')
132
810fa5c4 133%rpmldflags %(awk 'BEGIN {
c05a0741 134 split("%{?optldflags}",I);
810fa5c4 135 split("%{?filterout_ld}",F)
136 %{filter_out}
137}')
138
25f52d1a 139# rpmldflags with stripped -Wl, -- in the form flags have to be passed to 'ld'
140# but, don't use it, better use gcc as linker
141%ld_rpmldflags %(awk 'BEGIN {
142 split("%{rpmldflags}",F);
143 for (f in F) {
144 s = F[f];
145 if (s ~ /^-Wl,/) {
146 s = substr(s,5);
147 gsub(/,/," ",s);
148 };
149 printf(s FS);
150 };
151}')
152
8ef644e5 153#-----------------------------------------------------------------
154#
155# Generate a command which cleans environment, leaving only the
156# most important variables.
157# If any spec requires any additional environment it should
158# redefine %_preserve_env in following manner:
159#
160# # ADDITIONAL_VAR is required because [a good reason here]
82d10503 161# %define _preserve_env ADDITIONAL_VAR
8ef644e5 162
57ba0f59 163%_preserve_env_base PATH HOME TMP TMPDIR SSH_AUTH_SOCK
8ef644e5 164
bb597f2b
AM
165# "env -i" must end in first line of expaned macros because it's used as first line of shell script (#! env...)
166%_clean_env %{!?_preserve_env:%global _preserve_env %{nil}}%{expand:%%global _preserve_env %{_preserve_env} %_preserve_env_base} env -i %(awk -vq="'" -vqq="\\"'\\"" -vq2q="'\\"'" 'BEGIN {
0bdc88ec 167 split("%{?_preserve_env}", P);
a363d727
ER
168 for (i in P) {
169 p = P[i];
82d10503
ER
170 if (!ENVIRON[p] || d[p]) {
171 continue;
8ef644e5 172 }
82d10503
ER
173 d[p] = 1;
174 split(ENVIRON[p], V, "");
175 val = p "=";
176 for (j = 1; j in V; j++) {
177 v = V[j];
178 if (v == q)
179 v = qq;
180 else if (v == "\\"")
181 v = q2q;
182 else if (v == "\\\\")
183 v = "\\\\\\\\";
184 else
185 gsub("[^a-zA-Z0-9/:._-]", "\\"&\\"", v);
186 val = val "" v;
187 }
188 printf(val " ");
8ef644e5 189 }
190}')
191
9c404149 192#-----------------------------------------------------------------
9f4ce098 193%configure2_13 { \
9c404149
AM
194 if [ -n "$LINGUAS" ]; then unset LINGUAS; fi; \
195 LDFLAGS="${LDFLAGS:-%rpmldflags}" ; export LDFLAGS ; \
196 CFLAGS="${CFLAGS:-%rpmcflags}" ; export CFLAGS ; \
f4cc8832 197 CXXFLAGS="${CXXFLAGS:-%rpmcxxflags}" ; export CXXFLAGS ; \
9c404149 198 FFLAGS="${FFLAGS:-%rpmcflags}" ; export FFLAGS ; \
e9d801f4 199 FCFLAGS="${FCFLAGS:-%rpmcflags}" ; export FCFLAGS ; \
98e7f050 200 CPPFLAGS="${CPPFLAGS:-%rpmcppflags}" ; export CPPFLAGS ; \
8983c4c4
AM
201 %{?__cc:CC="%{__cc}" ; export CC ; } \
202 %{?__cxx:CXX="%{__cxx}" ; export CXX ; } \
8f74418b 203 %{?configuredir:%{configuredir}}%{!?configuredir:.}/configure \
2a7cfd3f 204 --host=%{_target_platform} \
9c404149
AM
205 --prefix=%{_prefix} \
206 --exec-prefix=%{_exec_prefix} \
207 --bindir=%{_bindir} \
208 --sbindir=%{_sbindir} \
209 --sysconfdir=%{_sysconfdir} \
210 --datadir=%{_datadir} \
211 --includedir=%{_includedir} \
212 --libdir=%{_libdir} \
213 --libexecdir=%{_libexecdir} \
214 --localstatedir=%{_localstatedir} \
215 --sharedstatedir=%{_sharedstatedir} \
216 --mandir=%{_mandir} \
217 --infodir=%{_infodir} \
b6c5da52 218 --x-libraries=%{?_x_libraries}%{!?_x_libraries:%{_libdir}} \
93059874 219 %{dependencytracking} \
9c404149
AM
220}
221
39b9534b
ER
222%cmake { \
223CC="%{__cc}" \
224CXX="%{__cxx}" \
225CFLAGS="%{rpmcflags}" \
226CXXFLAGS="%{rpmcxxflags}" \
12513dc1 227LDFLAGS="%{rpmldflags}" \
89f4ca1f
ER
228%{__cmake} \
229}
230
89f4ca1f
ER
231%scons { \
232%{__scons} \
5c76736d
ER
233 LDFLAGS="${LDFLAGS:-%rpmldflags}" \
234 CFLAGS="${CFLAGS:-%rpmcflags}" \
235 CXXFLAGS="${CXXFLAGS:-%rpmcxxflags}" \
236 FFLAGS="${FFLAGS:-%rpmcflags}" \
98e7f050 237 CPPFLAGS="${CPPFLAGS:-%rpmcppflags}" \
5c76736d
ER
238 %{?__cc:CC="%{__cc}"} \
239 %{?__cxx:CXX="%{__cxx}"} \
240 libsuffix=%{_lib} \
241 prefix=%{_prefix} \
39b9534b
ER
242}
243
6339d32d 244# waf. see waf.spec
6339d32d 245%waf { \
6339d32d
ER
246CC="%{__cc}" \
247CXX="%{__cxx}" \
9e244007 248CPP="%{__cpp}" \
6339d32d
ER
249CFLAGS="%{rpmcflags}" \
250CXXFLAGS="%{rpmcxxflags}" \
251%{__waf} \
6339d32d
ER
252}
253
4a6b0d54 254#----------------------------------------------------------------
9bacbb5b 255#%configure_cache 0
fe6c4bdd 256%configure_cache_file %{buildroot}.configure.cache
73f832b3 257
e84cd836 258%configure {./configure \
4a6b0d54
AF
259 LDFLAGS="${LDFLAGS:-%rpmldflags}" \
260 CFLAGS="${CFLAGS:-%rpmcflags}" \
f4cc8832 261 CXXFLAGS="${CXXFLAGS:-%rpmcxxflags}" \
4a6b0d54 262 FFLAGS="${FFLAGS:-%rpmcflags}" \
e9d801f4 263 FCFLAGS="${FCFLAGS:-%rpmcflags}" \
98e7f050 264 CPPFLAGS="${CPPFLAGS:-%rpmcppflags}" \
8983c4c4
AM
265 %{?__cc:CC="%{__cc}"} \
266 %{?__cxx:CXX="%{__cxx}"} \
8e4cb85a 267 --host=%{_target_platform} \
4a6b0d54
AF
268 --build=%{_target_platform} \
269 --prefix=%{_prefix} \
270 --exec-prefix=%{_exec_prefix} \
271 --bindir=%{_bindir} \
272 --sbindir=%{_sbindir} \
273 --sysconfdir=%{_sysconfdir} \
274 --datadir=%{_datadir} \
275 --includedir=%{_includedir} \
276 --libdir=%{_libdir} \
277 --libexecdir=%{_libexecdir} \
278 --localstatedir=%{_localstatedir} \
279 --sharedstatedir=%{_sharedstatedir} \
280 --mandir=%{_mandir} \
281 --infodir=%{_infodir} \
b6c5da52 282 --x-libraries=%{?_x_libraries}%{!?_x_libraries:%{_libdir}} \
93059874 283 %{dependencytracking} \
9bacbb5b 284 %{?configure_cache:--cache-file=%{configure_cache_file}} \
4a6b0d54
AF
285}
286
611a25d5 287# Simple macros to simplify adding bconded options to configure scripts.
288# Each macro requires bcond name and accepts optional option name, if option
289# isn't specified bcond name is used as option name. Options returning
290# --with and --enable also allow third argument which will be added as value
291# ( --with-option=value or --enable-option=value ) in case or positive
292# condition, but won't be added otherwise ( nothing or just --disable-option ).
293
294# Requirements:
295# BuildRequires: rpmbuild(macros) >= 1.527
296
297# Usage example:
298# %{__enable bcond} - returns --enable-bcond iff build condition is set
299# %{__disable bcond option} - returns --enable-option iff bcond is not set
300# %{__enable_disable bcond option value} - returns --enable-option=value if
301# bcond is set, returns --disable-option otherwise
302
303# expand bconds to --enable-something and --disable-something
304%__enable() %{expand:%%{?with_%{1}:--enable-%{?2}%{!?2:%{1}}%{?3:=%{3}}}}
305%__disable() %{expand:%%{!?with_%{1}:--disable-%{?2}%{!?2:%{1}}}}
306%__enable_disable() %{expand:%%{?with_%{1}:--enable-%{?2}%{!?2:%{1}}%{?3:=%{3}}}%%{!?with_%{1}:--disable-%{?2}%{!?2:%{1}}}}
307
308# same as above, but condition inverted
309%__enable_unless() %{expand:%%{!?with_%{1}:--enable-%{?2}%{!?2:%{1}}%{?3:=%{3}}}}
310%__disable_if() %{expand:%%{?with_%{1}:--disable-%{?2}%{!?2:%{1}}}}
311%__enable_disable_not() %{expand:%%{!?with_%{1}:--enable-%{?2}%{!?2:%{1}}%{?3:=%{3}}}%%{?with_%{1}:--disable-%{?2}%{!?2:%{1}}}}
312
313# expand bconds to --with-something and --without-something
314%__with() %{expand:%%{?with_%{1}:--with-%{?2}%{!?2:%{1}}%{?3:=%{3}}}}
315%__without() %{expand:%%{!?with_%{1}:--without-%{?2}%{!?2:%{1}}}}
316%__with_without() %{expand:%%{?with_%{1}:--with-%{?2}%{!?2:%{1}}%{?3:=%{3}}}%%{!?with_%{1}:--without-%{?2}%{!?2:%{1}}}}
317
318# same as above, but condition inverted
319%__with_unless() %{expand:%%{!?with_%{1}:--with-%{?2}%{!?2:%{1}}%{?3:=%{3}}}}
320%__without_if() %{expand:%%{?with_%{1}:--without-%{?2}%{!?2:%{1}}}}
321%__with_without_not() %{expand:%%{!?with_%{1}:--with-%{?2}%{!?2:%{1}}%{?3:=%{3}}}%%{?with_%{1}:--without-%{?2}%{!?2:%{1}}}}
322
323#-----------------------------------------------------------------
324
b3b1397b
ER
325# overload to insert debuginfo package
326%prep \
327%if 0%{?_enable_debug_packages}\
328%{debug_package}\
329%endif\
330%%prep\
331%{nil}
332
9c404149 333# Location of autoconf macros
7f0f4a79 334%_aclocaldir %{expand:%%global _aclocaldir %(aclocal --print-ac-dir || echo ERROR)}%_aclocaldir
9c404149 335
e2804f99 336# Location of omf files
7f0f4a79 337%_omf_dest_dir %{expand:%%global _omf_dest_dir %(scrollkeeper-config --omfdir || echo ERROR)}%_omf_dest_dir
e2804f99 338
e987a186 339# Location of pkgconfig files
9a4e877a 340%_pkgconfigdir /usr/%{_lib}/pkgconfig
36219c36
JB
341# noarch pkgconfig files
342%_npkgconfigdir /usr/share/pkgconfig
e987a186 343
486b0b5f 344# Location of desktop files
345%_desktopdir /usr/share/applications
86dff2d0 346%_applnkdir ERROR:_applnkdir_is_obsolete_use_desktopdir_instead
486b0b5f 347
481463e9 348# Location of pixmaps for applnk/desktop files
e1f0a822 349%_pixmapsdir /usr/share/pixmaps
9c404149 350
481463e9 351# Location of themable icons for applnk/desktop files
b36c8e2a 352%_iconsdir /usr/share/icons
353
e987a186
JB
354# Location of fonts directories
355%_fontsdir /usr/share/fonts
356
b3282f3f 357# Location of Gtk and associated libraries documentation
fe6c4bdd 358%_gtkdocdir %{_defaultdocdir}/gtk-doc/html
b3282f3f 359
fc4d7771 360# Location of KDE documentation
fe6c4bdd 361%_kdedocdir %{_defaultdocdir}/kde/HTML
fc4d7771 362
5869828c 363# unsermake script
364%__unsermake /usr/share/unsermake/unsermake
365
9c404149 366# Current date
8cf161e2 367%date %(LC_ALL=C date +"%a %b %d %Y")
9c404149 368
9c404149
AM
369# Example files, programs, scripts...
370%_examplesdir /usr/src/examples
371
c8f7e820 372# Alternative kernel type/version
261729d9 373%_alt_kernel %{nil}%{?alt_kernel:-%{?alt_kernel}}
c8f7e820 374
8377d27d 375# The directory holding Linux kernel sources
261729d9 376%_kernelsrcdir /usr/src/linux%{_alt_kernel}
8377d27d 377
c0fe61f0
ER
378# SysV-style initscripts dir
379%_initddir /etc/rc.d/init.d
380
9c404149 381# If non-empty "debug" macro defined, add "dbg" suffix to release number
8f74418b 382%_rpmfilename %%{NAME}-%%{VERSION}-%%{RELEASE}%{?debug:dbg}.%%{ARCH}.rpm
9c404149 383
c924d9d8
ER
384# -n drm to generate kernel%{_alt_kernel}-drm dependency
385%releq_kernel(n:) %{expand:%%global releq_kernel %(R=$(LC_ALL=C rpm -q --qf '%{N}%{?-n:-%{-n*}} = %|E?{%{E}:}|%{V}-%{R}' -f %{_kernelsrcdir}/include/linux/version.h 2>/dev/null | grep -v 'is not' | sed -e 's:-headers::;s:-config::'); echo ${R:-ERROR})}%releq_kernel
386%releq_kernel_up(n:) %{expand:%%global releq_kernel_up %(R=$(LC_ALL=C rpm -q --qf '%{N}%{?-n:-%{-n*}}-up = %|E?{%{E}:}|%{V}-%{R}' -f %{_kernelsrcdir}/include/linux/version.h 2>/dev/null | grep -v 'is not' | sed -e 's:-headers::;s:-config::'); echo ${R:-ERROR})}%releq_kernel_up
387%releq_kernel_smp(n:) %{expand:%%global releq_kernel_smp %(R=$(LC_ALL=C rpm -q --qf '%{N}%{?-n:-%{-n*}}-smp = %|E?{%{E}:}|%{V}-%{R}' -f %{_kernelsrcdir}/include/linux/version.h 2>/dev/null | grep -v 'is not' | sed -e 's:-headers::;s:-config::'); echo ${R:-ERROR})}%releq_kernel_smp
8bf3719d 388
c924d9d8 389# -s post to generate Requires(post) dependency
63d9963a
ER
390%requires_releq_kernel(s:n:) Requires%{-s:(%{-s*})}: %releq_kernel
391%requires_releq_kernel_up(s:n:) Requires%{-s:(%{-s*})}: %releq_kernel_up
392%requires_releq_kernel_smp(s:n:) Requires%{-s:(%{-s*})}: %releq_kernel_smp
8bf3719d 393
410df6e8
ER
394# Requires name = version-release
395%requires_releq() %{!?1:ERROR}%{?2:ERROR}%{?1:%{!?2:%{expand:%%requires_eq_to -r %1 %1}}}
8cf161e2 396# Requires: name = version
91d2f1eb 397%requires_eq() %{!?1:ERROR}%{?2:ERROR}%{?1:%{!?2:%{expand:%%requires_eq_to %1 %1}}}
8cf161e2 398# Requires: name = version (version based on querying package %2)
0d3e64c0 399%requires_eq_to(r) %{!?2:ERROR}%{?3:ERROR}%{?2:%{!?3:%(if ! LC_ALL=C rpm -q --qf 'Requires: %1 = %|E?{%{E}:}|%{V}%{?-r:-%{R}}\\n' %2 | grep '^Requires:'; then echo "BuildRequires: %2"; fi)}}
01a9f990 400
c94807f3 401%apache_modules_api %{expand:%%global apache_modules_api %(awk '/#define MODULE_MAGIC_NUMBER_MAJOR/ {print $3}' /usr/include/apache/ap_mmn.h 2>/dev/null || echo ERROR)}%apache_modules_api
b9d5d440 402
403# kernel version-release handling
95125403
ER
404%__kernel_ver %{expand:%%global __kernel_ver %( \\
405 Z=$(awk -F'"' '/UTS_RELEASE/{print $2}' %{_kernelsrcdir}/include/linux/{version,utsrelease}.h 2>/dev/null); \\
406 Z=${Z:-$(awk -F' = ' '/^VERSION/{v=$2} /^PATCHLEVEL/{p=$2} /^SUBLEVEL/{s=$2} /^EXTRAVERSION/{e=$2} END {printf("%d.%d.%d%s", v, p, s, e)}' %{_kernelsrcdir}/Makefile 2>/dev/null)}; \\
407 echo ${Z:-ERROR}; \\
1a7d3518 408)}%__kernel_ver
95125403 409
c94807f3
ER
410%__kernel_rel %{expand:%%global __kernel_rel %(Z=$(LC_ALL=C rpm -qf %{_kernelsrcdir}/include/linux/fs.h 2>/dev/null --qf "%{R}" | grep -v "is not"); echo ${Z:-ERROR})}%__kernel_rel
411%__kernel_rpmvr %{expand:%%global __kernel_rpmvr %(Z=$(LC_ALL=C rpm -qf %{_kernelsrcdir}/include/linux/fs.h 2>/dev/null --qf "%{V}-%{R}" | grep -v "is not"); echo ${Z:-ERROR})}%__kernel_rpmvr
412%_kernel_ver %{expand:%%global _kernel_ver %{__kernel_ver}%{?with_dist_kernel:%(echo %{__kernel_ver} | grep -q -e - || echo -%{__kernel_rel})}}%_kernel_ver
413%_kernel_ver_str %{expand:%%global _kernel_ver_str %(echo %{!?_without_dist_kernel:%{__kernel_rpmvr}}%{?_without_dist_kernel:%{__kernel_ver}} | sed -e 's/-/_/g')}%_kernel_ver_str
87be1cf0 414
6262f001
ER
415# `uname -r` to be used in @release field
416%_kernel_vermagic %{expand:%%global _kernel_vermagic %(echo %{_kernel_ver} | sed -e 's/-/_/g')}%_kernel_vermagic
417
e00dd7f6 418# sgml macros
3241033b
ER
419%xmlcat_add() /usr/bin/xmlcatalog --noout --add nextCatalog \"\" %1 /etc/xml/catalog ;
420%xmlcat_del() /usr/bin/xmlcatalog --noout --del %1 /etc/xml/catalog ;
421%xmlcat_add_rewrite /usr/bin/xmlcatalog --noout --add rewriteSystem
422%xmlcat_create() /usr/bin/xmlcatalog --noout --create %1 ;
423%sgmlcat_add() /usr/bin/install-catalog --add %1 %2 > /dev/null ;
424%sgmlcat_del() /usr/bin/install-catalog --remove %1 %2 > /dev/null ;
e00dd7f6 425%docbook_sgmlcat_fix() { for l in \
426'' \
427' -- default decl --' \
428'DTDDECL "-//OASIS//DTD DocBook XML V%2//EN" "../../xml.dcl"' \
429' -- hacks for opensp --' \
430'SYSTEM "file://%{_datadir}/sgml/docbook/xml-dtd-%2/docbookx.dtd" "%{_datadir}/sgml/docbook/xml-dtd-%2/docbookx.dtd"' \
431'SYSTEM "http://www.oasis-open.org/docbook/xml/%2/docbookx.dtd" "%{_datadir}/sgml/docbook/xml-dtd-%2/docbookx.dtd"' \
432'' \
433; do echo $l; done >> %1 \
434}
435
eea64748
ER
436# vim - "
437
4f044018
ER
438# minimum file size needed for compressed documents.
439# just smaller files than this get larger when compressed.
a88ae20f
ER
440# some stats:
441# - 0 byte file compressed was 25 bytes .gz
442# - 39 byte file was compressed as 57
443# - with test/test.spec@man 158 byte file was compressed also 158
444%_min_compress_bytes 159
4f044018 445
9c404149
AM
446#-----------------------------------------------------------------
447# find and gzip all files in %{_mandir} and %{infodir}
448#
449# Requires: xargs, find
450#
451#%no_install_post_compress_docs 1
452%__spec_install_post_compress_docs { \
53d5af13 453%{!?no_install_post_compress_docs:__spec_install_post_compress_docs() { \
4e10ec06 454 for i in /usr/share/man /usr/X11R6/man; do \
9c404149 455 if [ -d "$RPM_BUILD_ROOT$i" ]; then \
4e10ec06 456 echo "Compress man pages: $i"; \
4f044018
ER
457 find "$RPM_BUILD_ROOT$i" -name '*.bz2' -print | xargs -r %{__bzip2} -df; \
458 find "$RPM_BUILD_ROOT$i" -name '*.gz' -print | xargs -r %{__gzip} -dnf; \
6375241c
ER
459 find $RPM_BUILD_ROOT$i -type l | while read a; do \
460 m=$(readlink $a); \
461 rm -f $a; \
462 echo .so ${m##*/} > $a; \
463 echo >&2 "Converted ${a#$RPM_BUILD_ROOT} from symlink to man link: ${m##*/}"; \
464 done; \
4f044018 465 find "$RPM_BUILD_ROOT$i" -type f -size +%{_min_compress_bytes}c -print | xargs -r %{__gzip} -9nf; \
9c404149
AM
466 fi; \
467 done; \
728ad671
JB
468 if [ -d "$RPM_BUILD_ROOT%{_infodir}" ]; then \
469 echo "Compress info pages: %{_infodir}"; \
470 find "$RPM_BUILD_ROOT%{_infodir}" -name '*.bz2' -print | xargs -r %{__bzip2} -df; \
471 find "$RPM_BUILD_ROOT%{_infodir}" -name '*.gz' -print | xargs -r %{__gzip} -dnf; \
472 find "$RPM_BUILD_ROOT%{_infodir}" -name '*.info*' -type f -size +%{_min_compress_bytes}c -print | xargs -r %{__gzip} -9nf; \
4e10ec06 473 fi; \
53d5af13 474}; __spec_install_post_compress_docs } }
9c404149
AM
475
476#-----------------------------------------------------------------
477# Strip executable binaries and shared object files
478#
479# Requires: find, awk, strip, cut, xargs
480#
a2ad2754
JB
481# Special macros which affect this process:
482#%no_install_post_strip 1 # disable stripping at all
483#%_noautostrip regexp # exclude files matching (anchored!) regex from stripping
484#%_autostripall regexp # strip files matching (anchored!) regex using plain strip
485#%_autostripunneeded regexp # strip files matching (anchored!) regex using strip --strip-unneeded
486#%_autostripdebug regexp # strip files matching (anchored!) regex using strip --strip-debug
487#
9c404149 488%__spec_install_post_strip {%{!?debug: \
53d5af13 489%{!?no_install_post_strip:__spec_install_post_strip() { \
98a06bad 490if [ -d "$RPM_BUILD_ROOT" ]; then \
eea64748
ER
491 if [ -d $RPM_BUILD_ROOT/lib/modules ]; then \
492 modulelist=$(find $RPM_BUILD_ROOT/lib/modules -name '*o' -type f -print); \
4d5370ac
ER
493 if [ "$modulelist" ]; then \
494 modulecount=$(echo "$modulelist" | wc -l); \
737fefdc 495 printf "Stripping %d kernel modules..." $modulecount; \
3df8db34
ER
496 echo "$modulelist" | xargs -l512 chmod u+w; \
497 echo "$modulelist" | xargs -l512 %{__strip} --strip-unneeded --remove-section=.comment --remove-section=.note.GNU-stack; \
498 echo "DONE"; \
499 fi; \
eea64748 500 fi; \
0ac49134 501 filelist=$(find $RPM_BUILD_ROOT -type f ! -regex ".*/usr/lib[0-9]*/debug/.*\.debug" ! -regex ".*/lib/modules/.*" ! -regex ".*%{_docdir}/.*" ! -regex ".*%{_includedir}/.*" %{?_noautostrip:! -regex "%{_noautostrip}"} %{?_autostripall:! -regex "%{_autostripall}"} %{?_autostripunneeded:! -regex "%{_autostripunneeded}"} %{?_autostripdebug:! -regex "%{_autostripdebug}"}); \
f89ccb5f
JB
502 if [ -n "$filelist" ]; then \
503 filetypes=`echo "$filelist" | xargs -r -d'\\n' file`; \
504 elfexelist=`echo "$filetypes" | awk -F: '/ELF.*executable/ {print $1}'`; \
505 elfsharedlist=`echo "$filetypes" | awk -F: '/LF.*shared object/ {print $1}'`; \
a2ad2754 506 archiveslist=`echo "$filetypes" | awk -F: '/current ar archive/ {print $1}'`; \
f89ccb5f 507 if [ -n "$elfexelist" ]; then \
4d5370ac 508 printf "Stripping %d ELF executables..." $(echo "$elfexelist" | wc -l); \
f89ccb5f
JB
509 chmod u+w $elfexelist; \
510 %{__strip} --remove-section=.note --remove-section=.comment $elfexelist; \
511 echo "DONE"; \
512 fi; \
513 if [ -n "$elfsharedlist" ]; then \
4d5370ac 514 printf "Stripping %d ELF shared libraries..." $(echo "$elfsharedlist" | wc -l); \
f89ccb5f
JB
515 chmod u+w $elfsharedlist; \
516 %{__strip} --strip-unneeded --remove-section=.note --remove-section=.comment $elfsharedlist; \
517 echo "DONE"; \
518 fi; \
519 if [ -n "$archiveslist" ]; then \
4d5370ac 520 printf "Stripping %d ar archives..." $(echo "$archiveslist" | wc -l); \
f89ccb5f
JB
521 chmod u+w $archiveslist; \
522 %{__strip} --strip-debug --remove-section=.note --remove-section=.comment $archiveslist; \
523 echo "DONE"; \
524 fi; \
98a06bad 525 fi; \
0ac49134
ER
526 filelist_all=%{?_autostripall:$(find $RPM_BUILD_ROOT -type f -regex "%{_autostripall}")}; \
527 filelist_unneeded=%{?_autostripunneeded:$(find $RPM_BUILD_ROOT -type f -regex "%{_autostripunneeded}")}; \
528 filelist_debug=%{?_autostripdebug:$(find $RPM_BUILD_ROOT -type f -regex "%{_autostripdebug}")}; \
f89ccb5f 529 if [ -n "$filelist_all" ]; then \
4d5370ac 530 printf "Stripping everything from %d additional files..." $(echo "$filelist_all" | wc -l); \
a2ad2754 531 chmod u+w $filelist_all; \
f89ccb5f 532 %{__strip} --remove-section=.note --remove-section=.comment $filelist_all; \
322f84b9 533 echo "DONE"; \
9c404149 534 fi; \
f89ccb5f 535 if [ -n "$filelist_unneeded" ]; then \
4d5370ac 536 printf "Stripping unneeded from %d additional files..." $(echo "$filelist_unneeded" | wc -l); \
a2ad2754 537 chmod u+w $filelist_unneeded; \
f89ccb5f 538 %{__strip} --strip-unneeded --remove-section=.note --remove-section=.comment $filelist_unneeded; \
322f84b9 539 echo "DONE"; \
8f74418b 540 fi; \
f89ccb5f 541 if [ -n "$filelist_debug" ]; then \
4d5370ac 542 printf "Stripping debuginfo from %d additional files..." $(echo "$filelist_debug" | wc -l); \
a2ad2754 543 chmod u+w $filelist_debug; \
f89ccb5f 544 %{__strip} --strip-debug --remove-section=.note --remove-section=.comment $filelist_debug; \
322f84b9 545 echo "DONE"; \
9f0d4f36 546 fi; \
53d5af13 547fi; }; __spec_install_post_strip } } }
3241033b 548
fc5d7e20 549#-----------------------------------------------------------------
550# remove all RPATH from executable binaries and shared object files
551#
552# Requires: find, awk, cut, xargs, chrpath, uname
553#
a2ad2754
JB
554# Special macros which affect this process
555#%no_install_post_chrpath 1 # disable chrpath at all
556#%_noautochrpath regex # exclude files matching (anchored!) regex from chrpath
557#
fc5d7e20 558%__spec_install_post_chrpath {%{!?debug: \
53d5af13 559%{!?no_install_post_chrpath: __spec_install_post_chrpath() { \
9f0d4f36 560if [ -d "$RPM_BUILD_ROOT" ]; then \
0ac49134 561 files=`find $RPM_BUILD_ROOT -type f ! -regex ".*ld-[0-9.]*so.*" ! -regex ".*/usr/lib[0-9]*/debug/.*" ! -regex ".*/lib/modules/.*" ! -regex ".*%{_docdir}/.*" ! -regex ".*%{_includedir}/.*" %{?_noautochrpath:! -regex "%{_noautochrpath}"}`; \
98a06bad 562 if [ -n "$files" ]; then \
d5517264 563 objs=`echo "$files" | xargs -r -d'\\n' file | awk -F: '/ELF.*(executable.*dynamically linked|shared object)/ {print $1}'`; \
3401a2cd 564 fi; \
98a06bad 565 if [ -n "$objs" ]; then \
4d5370ac 566 printf "Remove RPATH from %d executable binaries and shared object files.\n" $(echo "$objs" | wc -l); \
98a06bad
ER
567 echo "$objs" | \
568 while read file; do \
569 rpath= ; \
570 chmod u+w "$file"; \
5541bf26 571 for dir in $(chrpath -l "$file" | awk '/RPATH=/ { gsub(/.*RPATH=/,""); gsub(/:/," "); print $0 }'); do \
eda6b510
AM
572 case $dir in \
573 '$ORIGIN' ) \
574 if [ "$rpath" = "" ] ; then rpath="$dir" ; \
575 else rpath="$rpath:$dir" ; fi ; \
576 continue ; \
577 ;; \
578 esac ; \
f9abaddb
AM
579 newdir=$(readlink -m "$dir"); \
580 [ ${#newdir} -le ${#dir} ] && dir=$newdir; \
98a06bad
ER
581 case $dir in \
582 /home/* | /tmp/* | /usr/lib | /usr/lib64 | /lib | /lib64 | /usr/local/lib | /usr/local/lib64 | /usr/X11R6/lib | /usr/X11R6/lib64 ) \
583 echo "remove-rpath: $dir in $file"; \
584 ;; \
585 * ) \
586 if [ "$rpath" = "" ] ; then rpath="$dir" ; \
587 else rpath="$rpath:$dir" ; fi ; \
588 ;; \
589 esac ; \
590 done ; \
591 if [ "$rpath" = "" ] ; then chrpath -d "$file" > /dev/null ; \
592 else chrpath -r "$rpath" "$file" > /dev/null ; fi ; \
593 done; \
594 fi; \
53d5af13 595fi; }; __spec_install_post_chrpath } } }
3241033b 596
611a25d5 597# vim: "
598
d366d7e0
AM
599#-----------------------------------------------------------------
600# Find all shared object files with unresolved symbols. Warn
601# and terminate if any found (termination can be turned off by define).
602#%no_install_post_check_so 1
603%__spec_install_post_check_so { \
604 __spec_install_post_check_so() { \
605 fail=0; \
606 printf "Searching for shared objects with unresolved symbols..."; \
34906a2d 607 for f in $(find $RPM_BUILD_ROOT -type f -name '*.so.*' -print); do \
7df9ddfc 608 LC_ALL=C objdump -T $f 2> /dev/null | LC_ALL=C awk -v "file=$f" 'BEGIN { found=0; skip["program_name"]=1; symbols = "" } /^[0-9a-z]+ +D +\*UND\*/ { if ($NF in skip) { next; }; found = 1; symbols = symbols "\n\t" $NF } END { if (found) { print "\nUnresolved symbols found in: " file symbols; exit(1); } } ' || fail=1 ; \
d366d7e0
AM
609 done ; \
610 echo " DONE"; \
14ae3117 611 %{!?no_install_post_check_so:[ $fail -eq 1 ] && : || :;} \
d366d7e0
AM
612}; __spec_install_post_check_so }}
613
d72c185f 614#-----------------------------------------------------------------
ccb8ae8d 615# Find and gzip all kernel modules
616#
617# Requires: find
618#
fe6c4bdd 619#%no_install_post_compress_modules 1
ccb8ae8d 620%__spec_install_post_compress_modules { \
53d5af13 621%{!?no_install_post_compress_modules: __spec_install_post_compress_modules() { \
f3bfe4ac 622 if [ -d $RPM_BUILD_ROOT/lib/modules ]; then \
f3bfe4ac 623 q=$(find $RPM_BUILD_ROOT/lib/modules -name '*o' -type f -print); \
4d5370ac
ER
624 if [ "$q" ]; then \
625 printf "Compress %d kernel modules..." $(echo "$q" | wc -l); \
626 echo "$q" | xargs -r %{__gzip} -9nf; \
627 echo "DONE"; \
628 find $RPM_BUILD_ROOT/lib/modules -name '*o' -type l -printf "%p %l\n" | \
629 while read a b; do ln -sf $b.gz $a.gz; rm -f $a; done; \
630 fi; \
3241033b 631 fi; \
53d5af13 632}; __spec_install_post_compress_modules } }
9c404149 633
ef64802f
ER
634# Remove common Perl files we don't package
635%__spec_install_post_perl_clean {\
636%{!?no_install_post_perl_clean: \
637%{?pdir:rm -f $RPM_BUILD_ROOT{%{perl_archlib}/perllocal.pod,%{perl_vendorarch}/auto/%{pdir}%{?pnam:/%(echo %{pnam} | tr - /)}/.packlist}} \
638} }
639
83094b62 640#-----------------------------------------------------------------
0e4cb4dd 641# Update GConf2 schemas
83094b62 642#
643# Requires: GConf2
644#
46885239 645%gconf_schema_install() \
307ac6c9
ER
646 umask 022; \
647 GCONF_CONFIG_SOURCE="xml:readwrite:/etc/gconf/gconf.xml.defaults" \\\
648 /usr/bin/gconftool-2 --makefile-install-rule /etc/gconf/schemas/%{?1}%{!?1:*.schemas} > /dev/null; \
f27cf2fd 649%{nil}
46885239 650
651%gconf_schema_uninstall() \
24336a54 652if [ $1 = 0 -a -x /usr/bin/gconftool-2 ]; then \
3241033b 653 umask 022; \
24336a54
ER
654 GCONF_CONFIG_SOURCE="xml:readwrite:/etc/gconf/gconf.xml.defaults" \\\
655 /usr/bin/gconftool-2 --makefile-uninstall-rule /etc/gconf/schemas/%{?1} > /dev/null \
f27cf2fd 656fi; \
f93109a0 657%{nil}
658
659#-----------------------------------------------------------------
660# Update desktop MIME database
c0a4caa0 661# requires: desktop-file-utils
c3bcd10e 662%update_desktop_database() {{ \
f93109a0 663 umask 022; \
fb59e475 664 /usr/bin/update-desktop-database -q; \
c00bf95c
MB
665};} \
666%{nil}
f93109a0 667
c3bcd10e
ER
668%update_desktop_database_post %update_desktop_database
669
670%update_desktop_database_postun() {{ \
f27cf2fd 671if [ "$1" = "0" ]; then \
c00bf95c 672 %update_desktop_database \
f27cf2fd 673fi; \
c00bf95c
MB
674};} \
675%{nil}
f93109a0 676
fb59e475 677#-----------------------------------------------------------------
678# Update shared MIME info database
679# requires: shared-mime-info
680#
c3bcd10e 681%update_mime_database() {{ \
fb59e475 682 umask 022; \
683 /usr/bin/update-mime-database %{_datadir}/mime; \
c00bf95c
MB
684};} \
685%{nil}
fb59e475 686
687#-----------------------------------------------------------------
688# Update icon cache
689# requires: gtk+
690#
c3bcd10e 691%update_icon_cache() {{ \
fb59e475 692 umask 022; \
072f4b80 693 /usr/bin/gtk-update-icon-cache -qf %{_datadir}/icons/%1; \
c00bf95c
MB
694};} \
695%{nil}
fb59e475 696
f93109a0 697#-----------------------------------------------------------------
698# Update scrollkeeper database
699# requires: scrollkeeper
700#
701%scrollkeeper_update_post() \
f93109a0 702 /usr/bin/scrollkeeper-update -q; \
f27cf2fd 703%{nil}
f93109a0 704
705%scrollkeeper_update_postun() \
f27cf2fd 706if [ "$1" = "0" ]; then \
f93109a0 707 /usr/bin/scrollkeeper-update -q; \
f27cf2fd 708fi; \
f93109a0 709%{nil}
710
9c404149
AM
711#-----------------------------------------------------------------
712# post %install sequence:
713# - autodeps exceptions
714# - compress all man and info pages,
715# - strip all ELF executables and ELF shared objects if not %debug.
8f74418b 716# - compress kernel modules if any
9c404149
AM
717
718###################################################################
719# Requires/Provides automation
3e202b06 720# exceptions system by Jacek Konieczny <jajcus@pld-linux.org>
338726a6 721#
2892b5df
JB
722%__noautoreqfiles %(sed -e s'/#.*//' /etc/rpm/noautoreqfiles)%{?_noautoreqfiles: %{_noautoreqfiles}}
723%__noautoprovfiles %(sed -e s'/#.*//' /etc/rpm/noautoprovfiles)%{?_noautoprovfiles: %{_noautoprovfiles}}
724%__noautoreq %(sed -e s'/#.*//' /etc/rpm/noautoreq)%{?_noautoreq: %{_noautoreq}}
725%__noautoreqdep %(sed -e s'/#.*//' /etc/rpm/noautoreqdep)%{?_noautoreqdep: %{_noautoreqdep}}
726%__noautoprov %(sed -e s'/#.*//' /etc/rpm/noautoprov)%{?_noautoprov: %{_noautoprov}}
c94807f3 727
338726a6
JB
728#%_noautocompressdoc %{nil}
729#
8f74418b
MM
730%_missing_doc_files_terminate_build 1%{nil}
731%_unpackaged_files_terminate_build %{nil}
8781dc74 732# (X)emacs support
d77dcb61 733%___emacs_lispdir_helper -batch -q -eval '(while load-path (princ (concat (car load-path) "\\n")) (setq load-path (cdr load-path)))' 2> /dev/null|sed -n '/\\(.*\\/x\\?emacs\\/site-lisp\\)\\/\\?$/{s,,\\1,p;q;}'
c94807f3
ER
734%_emacs_lispdir %{expand:%%global _emacs_lispdir %(Z=$(emacs %___emacs_lispdir_helper); echo ${Z:-ERROR})}%_emacs_lispdir
735%_xemacs_lispdir %{expand:%%global _xemacs_lispdir %(Z=$(xemacs %___emacs_lispdir_helper); echo ${Z:-ERROR})}%_xemacs_lispdir
25043cd4 736
02b58f60
JK
737%__php_provides %{nil}
738%__php_requires %{nil}
739%__perl_provides %{nil}
740%__perl_requires %{nil}
fa3497cd 741%__mono_provides %{nil}
742%__mono_requires %{nil}
25043cd4
AF
743
744# Perl specific macro definitions.
c94807f3
ER
745%perl_privlib %{expand:%%global perl_privlib %(eval $(%{__perl} -V:installprivlib 2>/dev/null); echo ${installprivlib:-ERROR})}%perl_privlib
746%perl_archlib %{expand:%%global perl_archlib %(eval $(%{__perl} -V:installarchlib 2>/dev/null); echo ${installarchlib:-ERROR})}%perl_archlib
747%perl_vendorlib %{expand:%%global perl_vendorlib %(eval $(%{__perl} -V:installvendorlib 2>/dev/null); echo ${installvendorlib:-ERROR})}%perl_vendorlib
748%perl_vendorarch %{expand:%%global perl_vendorarch %(eval $(%{__perl} -V:installvendorarch 2>/dev/null); echo ${installvendorarch:-ERROR})}%perl_vendorarch
749%perl_sitelib %{expand:%%global perl_sitelib %(eval $(%{__perl} -V:installsitelib 2>/dev/null); echo ${installsitelib:-ERROR})}%perl_sitelib
750%perl_sitearch %{expand:%%global perl_sitearch %(eval $(%{__perl} -V:installsitearch 2>/dev/null); echo ${installsitearch:-ERROR})}%perl_sitearch
25043cd4 751
45c00b39 752# Ruby
c94807f3
ER
753%__ruby /usr/bin/ruby
754%ruby_archdir %{expand:%%global ruby_archdir %(%{__ruby} -r rbconfig -e 'print Config::CONFIG["archdir"]' 2>/dev/null || echo ERROR)}%ruby_archdir
755%ruby_ridir %{expand:%%global ruby_ridir %(%{__ruby} -r rbconfig -e 'include Config; print File.join(CONFIG["datadir"], "ri", CONFIG["ruby_version"], "system")' 2>/dev/null || echo ERROR)}%ruby_ridir
756%ruby_rubylibdir %{expand:%%global ruby_rubylibdir %(%{__ruby} -r rbconfig -e 'print Config::CONFIG["rubylibdir"]' 2>/dev/null || echo ERROR)}%ruby_rubylibdir
757%ruby_vendorarchdir %{expand:%%global ruby_vendorarchdir %(%{__ruby} -r rbconfig -e 'print Config::CONFIG["vendorarchdir"]' 2>/dev/null || echo ERROR)}%ruby_vendorarchdir
758%ruby_vendorlibdir %{expand:%%global ruby_vendorlibdir %(%{__ruby} -r rbconfig -e 'print Config::CONFIG["vendorlibdir"]' 2>/dev/null || echo ERROR)}%ruby_vendorlibdir
759%ruby_sitearchdir %{expand:%%global ruby_sitearchdir %(%{__ruby} -r rbconfig -e 'print Config::CONFIG["sitearchdir"]' 2>/dev/null || echo ERROR)}%ruby_sitearchdir
760%ruby_sitelibdir %{expand:%%global ruby_sitelibdir %(%{__ruby} -r rbconfig -e 'print Config::CONFIG["sitelibdir"]' 2>/dev/null || echo ERROR)}%ruby_sitelibdir
751cfc9e 761%ruby_rdocdir /usr/share/rdoc
c94807f3 762%ruby_version %{expand:%%global ruby_version %(%{__ruby} -r rbconfig -e 'print Config::CONFIG["ruby_version"]' 2>/dev/null || echo ERROR)}%ruby_version
669604db
ER
763%ruby_ver_requires_eq Requires: ruby(ver) = %ruby_version
764%ruby_mod_ver_requires_eq Requires: ruby-modules(ver) = %ruby_version
45c00b39 765
7ccf7643 766%php_pear_dir /usr/share/pear
7813c433 767%php_data_dir /usr/share/php
c94807f3
ER
768%php_extensiondir %{expand:%%global php_extensiondir %(php-config --extension-dir 2>/dev/null || echo ERROR)}%php_extensiondir
769%php_sysconfdir %{expand:%%global php_sysconfdir %(php-config --sysconfdir 2>/dev/null || echo ERROR)}%php_sysconfdir
770%php_includedir %{expand:%%global php_includedir %(php-config --include-dir 2>/dev/null || echo ERROR)}%php_includedir
25043cd4 771
0c5d1b9b 772# extract php/zend api versions
c94807f3 773%php_major_version %{expand:%%global php_major_version %(awk '/#define PHP_MAJOR_VERSION/{print $3}' %{php_includedir}/main/php_version.h 2>/dev/null || echo ERROR)}%php_major_version
e0d35dd1 774%php_minor_version %{expand:%%global php_minor_version %(awk '/#define PHP_MINOR_VERSION/{print $3}' %{php_includedir}/main/php_version.h 2>/dev/null || echo ERROR)}%php_minor_version
c94807f3
ER
775%php_api_version %{expand:%%global php_api_version %(awk '/#define PHP_API_VERSION/{print $3}' %{php_includedir}/main/php.h 2>/dev/null || echo ERROR)}%php_api_version
776%php_pdo_api_version %{expand:%%global php_pdo_api_version %(awk '/#define PDO_DRIVER_API/{print $3}' %{php_includedir}/ext/pdo/php_pdo_driver.h 2>/dev/null || echo ERROR)}%php_pdo_api_version
777%php_debug %{expand:%%global php_debug %(awk '/#define ZEND_DEBUG/{print $3}' %{php_includedir}/main/php_config.h 2>/dev/null || echo ERROR)}%php_debug
778%zend_module_api %{expand:%%global zend_module_api %(awk '/#define ZEND_MODULE_API_NO/{print $3}' %{php_includedir}/Zend/zend_modules.h 2>/dev/null || echo ERROR)}%zend_module_api
779%zend_extension_api %{expand:%%global zend_extension_api %(awk '/#define ZEND_EXTENSION_API_NO/{print $3}' %{php_includedir}/Zend/zend_extensions.h 2>/dev/null || echo ERROR)}%zend_extension_api
780%zend_zts %{expand:%%global zend_zts %(Z=$(grep -sc '^#define ZTS 1' %{php_includedir}/main/php_config.h); echo ${Z:-ERROR})}%zend_zts
c1b2705c
ER
781
782# helper macro
f952c0f3 783%__php_api_requires(v:) Requires: php%{-v*}(%{expand:%1}) = %{expand:%{%{!?2:%{1}}%{?2}}}
c1b2705c
ER
784
785# macros for public use
786# for php extensions (php-pecl)
68b68193 787%requires_php_extension %{__php_api_requires modules_api php_api_version} \
415f4a1a 788%{__php_api_requires zend_module_api} \
f952c0f3
ER
789%{__php_api_requires -v %php_major_version debug php_debug} \
790%{__php_api_requires -v %php_major_version thread-safety zend_zts}
68b68193 791
c1b2705c
ER
792# for zend extensions
793%requires_zend_extension %{__php_api_requires zend_module_api} \
68b68193 794%{__php_api_requires zend_extension_api} \
f952c0f3
ER
795%{__php_api_requires -v %php_major_version debug php_debug} \
796%{__php_api_requires -v %php_major_version thread-safety zend_zts}
c1b2705c 797
934c685f
ER
798# for php pdo modules (php-pecl-PDO_*)
799%requires_php_pdo_module %{__php_api_requires PDO_API php_pdo_api_version}
800
6c3b8203
ER
801# for using PHP post scripts. for PHP >= 5.0
802%php_webserver_restart \
803[ ! -f /etc/apache/conf.d/??_mod_php.conf ] || %service -q apache restart \
578e7794 804[ ! -f /etc/httpd/conf.d/??_mod_php.conf ] || %service -q httpd restart \
8e2cfc36 805if [ -x /etc/rc.d/init.d/php-fcgi ]; then \
ba1800dc
ER
806 PHP_FCGI_BINARY=; . /etc/sysconfig/php-fcgi 2>/dev/null \
807 if [[ ${PHP_FCGI_BINARY:-php.fcgi} = *php.fcgi* ]]; then \
808 %service -q php-fcgi restart \
809 fi \
810fi \
8e2cfc36
ER
811if [ -x /etc/rc.d/init.d/php-fpm ]; then \
812 %service -q php-fpm restart \
813fi \
6c3b8203
ER
814%{nil}
815
816# for using php post scripts. for PHP >= 4.0 && PHP < 5.0
817%php4_webserver_restart \
818[ ! -f /etc/apache/conf.d/??_mod_php4.conf ] || %service -q apache restart \
578e7794 819[ ! -f /etc/httpd/conf.d/??_mod_php4.conf ] || %service -q httpd restart \
8e2cfc36 820if [ -x /etc/rc.d/init.d/php-fcgi ]; then \
ba1800dc
ER
821 PHP_FCGI_BINARY=; . /etc/sysconfig/php-fcgi 2>/dev/null \
822 if [[ ${PHP_FCGI_BINARY:-php.fcgi} = *php4.fcgi* ]]; then \
823 %service -q php-fcgi restart \
824 fi \
825fi \
6c3b8203
ER
826%{nil}
827
578e9248 828# X.org helper macros
434ab5a2
ER
829%__xorg_abi_requires_ge() Requires: xorg-xserver-server(%{expand:%1}-abi) >= %{expand:%{%2}}
830%__xorg_abi_requires_lt() Requires: xorg-xserver-server(%{expand:%1}-abi) < %(awk -vv=%{expand:%{%2}} 'BEGIN{split(v, a, "."); printf("%s.0", a[1] + 1); exit}')
831
c94807f3
ER
832%xorg_xserver_ansic_abi %{expand:%%global xorg_xserver_ansic_abi %(awk '/#define ABI_ANSIC_VERSION/ { split($0,A,/[(,)]/); printf("%d.%d",A[2], A[3]); }' /usr/include/xorg/xf86Module.h 2> /dev/null || echo ERROR)}%xorg_xserver_ansic_abi
833%xorg_xserver_extension_abi %{expand:%%global xorg_xserver_extension_abi %(awk '/#define ABI_EXTENSION_VERSION/ { split($0,A,/[(,)]/); printf("%d.%d",A[2], A[3]); }' /usr/include/xorg/xf86Module.h 2> /dev/null || echo ERROR)}%xorg_xserver_extension_abi
834%xorg_xserver_font_abi %{expand:%%global xorg_xserver_font_abi %(awk '/#define ABI_FONT_VERSION/ { split($0,A,/[(,)]/); printf("%d.%d",A[2], A[3]); }' /usr/include/xorg/xf86Module.h 2> /dev/null | echo ERROR)}%xorg_xserver_font_abi
835%xorg_xserver_videodrv_abi %{expand:%%global xorg_xserver_videodrv_abi %(awk '/#define ABI_VIDEODRV_VERSION/ { split($0,A,/[(,)]/); printf("%d.%d",A[2], A[3]); }' /usr/include/xorg/xf86Module.h 2> /dev/null || echo ERROR)}%xorg_xserver_videodrv_abi
836%xorg_xserver_xinput_abi %{expand:%%global xorg_xserver_xinput_abi %(awk '/#define ABI_XINPUT_VERSION/ { split($0,A,/[(,)]/); printf("%d.%d",A[2], A[3]); }' /usr/include/xorg/xf86Module.h 2> /dev/null || echo ERROR)}%xorg_xserver_xinput_abi
611a25d5 837# vim: '
578e9248 838
434ab5a2 839%requires_xorg_xserver_extension \
97486460
AM
840%{__xorg_abi_requires_ge ansic xorg_xserver_ansic_abi} \
841%{__xorg_abi_requires_lt ansic xorg_xserver_ansic_abi} \
842%{__xorg_abi_requires_ge extension xorg_xserver_extension_abi} \
843%{__xorg_abi_requires_lt extension xorg_xserver_extension_abi} \
434ab5a2
ER
844%{nil}
845
846%requires_xorg_xserver_xinput \
97486460
AM
847%{__xorg_abi_requires_ge ansic xorg_xserver_ansic_abi} \
848%{__xorg_abi_requires_lt ansic xorg_xserver_ansic_abi} \
849%{__xorg_abi_requires_ge xinput xorg_xserver_xinput_abi} \
850%{__xorg_abi_requires_lt xinput xorg_xserver_xinput_abi} \
434ab5a2
ER
851%{nil}
852
853%requires_xorg_xserver_font \
97486460
AM
854%{__xorg_abi_requires_ge ansic xorg_xserver_ansic_abi} \
855%{__xorg_abi_requires_lt ansic xorg_xserver_ansic_abi} \
856%{__xorg_abi_requires_ge font xorg_xserver_font_abi} \
857%{__xorg_abi_requires_lt font xorg_xserver_font_abi} \
434ab5a2
ER
858%{nil}
859
860%requires_xorg_xserver_videodrv \
97486460
AM
861%{__xorg_abi_requires_ge ansic xorg_xserver_ansic_abi} \
862%{__xorg_abi_requires_lt ansic xorg_xserver_ansic_abi} \
863%{__xorg_abi_requires_ge videodrv xorg_xserver_videodrv_abi} \
864%{__xorg_abi_requires_lt videodrv xorg_xserver_videodrv_abi} \
434ab5a2 865%{nil}
578e9248 866
15d7cc4a
ER
867# TCL specific macro definitions.
868# TODO: when th tcl is fixed use tclsh to get version: %(echo 'puts $tcl_version' | tclsh)
869%tcl_version %{expand:%%global tcl_version %(v=$(rpm -q --qf %{V} tcl | cut -d. -f1,2); echo ${v:-ERROR})}%tcl_version
870%tcl_sitearch %{_libdir}/tcl%{tcl_version}
871%tcl_sitelib %{_datadir}/tcl%{tcl_version}
872
25043cd4
AF
873# Python specific macro definitions.
874# python main version
2383a9da 875%py_ver %{expand:%%global py_ver %(%{__python} -c "import sys; print sys.version[:3]" 2>/dev/null || echo ERROR)}%py_ver
25043cd4
AF
876
877# directories
2383a9da 878%py_prefix %{expand:%%global py_prefix %(%{__python} -c "import sys; print sys.prefix" 2>/dev/null || echo ERROR)}%py_prefix
3241033b 879%py_libdir %{py_prefix}/%{_lib}/python%{py_ver}
ef7ec0a8 880%py_scriptdir %{py_prefix}/share/python%{py_ver}
3241033b 881%py_incdir /usr/include/python%{py_ver}
7ccf7643 882%py_sitedir %{py_libdir}/site-packages
ef7ec0a8 883%py_sitescriptdir %{py_scriptdir}/site-packages
3241033b 884%py_dyndir %{py_libdir}/lib-dynload
25043cd4
AF
885
886# pure python modules compilation
3241033b 887%py_comp python -c "import compileall; import sys; compileall.compile_dir(sys.argv[1], ddir=sys.argv[1][len('$RPM_BUILD_ROOT'):])"
25043cd4 888
3241033b 889%py_ocomp python -O -c "import compileall; import sys; compileall.compile_dir(sys.argv[1], ddir=sys.argv[1][len('$RPM_BUILD_ROOT'):])"
25043cd4
AF
890
891# Software written in Python language require Python with main version
e63cd81d 892%pyrequires_eq() Requires: %1
25043cd4 893
4bf34b55
AF
894# Python 3.x
895# python main version
e9f00395 896%__python3 python3
4bf34b55
AF
897%py3_ver %{expand:%%global py3_ver %(%{__python3} -c "import sys; print(sys.version[:3])" 2>/dev/null || echo ERROR)}%py3_ver
898
899# directories
900%py3_prefix %{expand:%%global py3_prefix %(%{__python3} -c "import sys; print(sys.prefix)" 2>/dev/null || echo ERROR)}%py3_prefix
901%py3_libdir %{py3_prefix}/%{_lib}/python%{py3_ver}
902%py3_scriptdir %{py3_prefix}/share/python%{py3_ver}
903%py3_incdir /usr/include/python%{py3_ver}
904%py3_sitedir %{py3_libdir}/site-packages
905%py3_sitescriptdir %{py3_scriptdir}/site-packages
906%py3_dyndir %{py3_libdir}/lib-dynload
907
908# pure python modules compilation
909%py3_comp %{__python3} -c "import compileall; import sys; compileall.compile_dir(sys.argv[1], ddir=sys.argv[1][len('$RPM_BUILD_ROOT'):])"
910
911%py3_ocomp %{__python3} -O -c "import compileall; import sys; compileall.compile_dir(sys.argv[1], ddir=sys.argv[1][len('$RPM_BUILD_ROOT'):])"
912
f12c2314 913# Hardlink binary identical .pyc and .pyo files
f12c2314 914%__spec_install_post_py_hardlink {\
53d5af13 915%{!?no_install_post_py_hardlink: __spec_install_post_py_hardlink() { \
f35a1d62
ER
916local a b c=0 t=0; \
917if [ -d "$RPM_BUILD_ROOT" ]; then \
918 find "$RPM_BUILD_ROOT" -name '*.pyc' > __rpm_pyc; \
919 while read a; do \
920 b="${a%.pyc}.pyo"; \
921 if cmp -s "$a" "$b"; then \
922 ln -f "$a" "$b"; \
923 c=$((c + 1)); \
924 fi; \
925 t=$((t + 1)); \
926 done < __rpm_pyc; \
927 [ $t -gt 0 ] && printf "Hardlink Python files: %d/%d files hardlinked\n" $c $t; \
928 rm -f __rpm_pyc; \
929fi; \
53d5af13 930}; __spec_install_post_py_hardlink } }
f12c2314 931
9227b3f9 932# remove python sources, so that check-files won't complain
f12c2314 933%py_postclean() \
0f82e280 934for d in %{py_sitescriptdir} %{py_sitedir} %*; do \
820792a9 935 [ ! -d "$RPM_BUILD_ROOT$d" ] || find "$RPM_BUILD_ROOT$d" -name '*.py' -print0 | xargs -0r -l512 rm;\
f12c2314
AF
936done \
937%{nil}
938
4bf34b55
AF
939%py3_postclean() \
940for d in %{py3_sitescriptdir} %{py3_sitedir} %*; do \
941 [ ! -d "$RPM_BUILD_ROOT$d" ] || find "$RPM_BUILD_ROOT$d" -name '*.py' -print0 | xargs -0r -l512 rm;\
942done \
943%{nil}
944
0fc5cff8 945# depmod macro
946%depmod() { \
f6148427 947umask 022; \
0fc5cff8 948if [ -e /boot/System.map-%1 ]; then \
3241033b 949 /sbin/depmod -a -F /boot/System.map-%1 %1; \
0fc5cff8 950else \
3241033b
ER
951 if [ -e /boot/System.map ]; then \
952 /sbin/depmod -a -F /boot/System.map %1; \
953 else \
954 /sbin/depmod -a %1; \
955 fi \
0fc5cff8 956fi; \
957}
958
2afc6e64 959# XMMS specific macros
c94807f3
ER
960%xmms_prefix %{expand:%%global xmms_prefix %(xmms-config --prefix 2>/dev/null || echo ERROR)}%xmms_prefix
961%xmms_exec_prefix %{expand:%%global xmms_exec_prefix %(xmms-config --exec-prefix 2>/dev/null || echo ERROR)}%xmms_exec_prefix
962%xmms_version %{expand:%%global xmms_version %(xmms-config --version 2>/dev/null || echo ERROR)}%xmms_version
963%xmms_datadir %{expand:%%global xmms_datadir %(xmms-config --data-dir 2>/dev/null || echo ERROR)}%xmms_datadir
964%xmms_plugindir %{expand:%%global xmms_plugindir %(xmms-config --plugin-dir 2>/dev/null || echo ERROR)}%xmms_plugindir
965%xmms_visualization_plugindir %{expand:%%global xmms_visualization_plugindir %(xmms-config --visualization-plugin-dir 2>/dev/null || echo ERROR)}%xmms_visualization_plugindir
966%xmms_input_plugindir %{expand:%%global xmms_input_plugindir %(xmms-config --input-plugin-dir 2>/dev/null || echo ERROR)}%xmms_input_plugindir
967%xmms_output_plugindir %{expand:%%global xmms_output_plugindir %(xmms-config --output-plugin-dir 2>/dev/null || echo ERROR)}%xmms_output_plugindir
968%xmms_effect_plugindir %{expand:%%global xmms_effect_plugindir %(xmms-config --effect-plugin-dir 2>/dev/null || echo ERROR)}%xmms_effect_plugindir
969%xmms_general_plugindir %{expand:%%global xmms_general_plugindir %(xmms-config --general-plugin-dir 2>/dev/null || echo ERROR)}%xmms_general_plugindir
970
c28a1d6a 971%_target_base_arch %{expand:%%global _target_base_arch %(echo %{_target_cpu} | sed 's/i.86/i386/;s/athlon/i386/;s/pentium./i386/;s/amd64/x86_64/;s/ia32e/x86_64/;s/sparcv./sparc/')}%_target_base_arch
d1537778 972
848c0d68 973# user/group checking macros
974#
975# Usage:
976# %userremove myuser
977#
978%userremove /usr/lib/rpm/user_group.sh user del
979%groupremove /usr/lib/rpm/user_group.sh group del
980#
981# Usage:
982# if %usertestrm myuser; then
983# /usr/sbin/userdel -r myuser
984# Note:
985# use these macros only if you need to call userdel/groupdel with
986# a non-standard option or take an extra action; otherwise use the
987# %userremove/%groupremove macros
988#
989%usertestrm /usr/lib/rpm/user_group.sh user testrm
990%grouptestrm /usr/lib/rpm/user_group.sh group testrm
08d9b1f6
JK
991# user group membership management macros
992#
993# Usage:
efbc7726 994# %addusertogroup [-q] myuser agroup
08d9b1f6 995#
efbc7726
ER
996# -q if user or group don't exist, don't make big noise of it (MISSINGOK behaviour)
997#
998# Requirements:
999# BuildRequires: rpmbuild(macros) >= 1.515
2b29e157
ER
1000%addusertogroup(q) quiet=%{-q:1} /usr/lib/rpm/user_group.sh user addtogroup %*; \
1001%{nil}
72fcfcb3 1002
1003# banner support (useful in {pre,post}{,un} and triggers)
1004#
1005# Usage:
aa41c920 1006# %banner name [-a] [-e] [-n] [-tn] <<EOF
72fcfcb3 1007# the banner text, the banner text
aa41c920
ER
1008# the banner text, and following line
1009#EOF
1010# You can use any form of here-document, <<'EOF' <<-EOT will do.
1011# NOTE: if your use "<<-EOF", then You can actually indent inside here-document.
1012#
72fcfcb3 1013# -a - append to the banner
a8b9562a 1014# -e - send to stderr instead of stdout
628754cb 1015# -n - no show banner (overrides -t)
1016# -t - show only, if RPM_SCRIPTVERBOSITY >= n; default n=5
276a7b45
ER
1017#
1018# Tests:
1019# (rpm -E '%banner -e banner <<EOF'; echo -e 'hi\nEOF') > m; sh -x m
1020# rpm -E 'date | %banner -e banner' > m; sh -x m
1021#
afb54f6c 1022%banner(aent:) ( \
1b334fe4 1023RPM_SCRIPTVERBOSITY=5 \
1024[ -r /etc/sysconfig/rpm ] && . /etc/sysconfig/rpm \
1025if [ -x /usr/bin/banner.sh ]; then \
aa41c920 1026 CMD="/usr/bin/banner.sh %{-e:--stderr} %{!-n:$([ $RPM_SCRIPTVERBOSITY -ge %{-t:%{-t*}}%{!-t:5} ] && echo -s)} %{!-a:-m}%{-a:-M} %1" \
1b334fe4 1027else \
a8b9562a 1028 CMD="cat%{-e: >&2}" \
1b334fe4 1029fi \
276a7b45
ER
1030eval $CMD %{?2:%2}%{?3: %3}) \
1031%{nil}
628754cb 1032
990bd03f 1033# useradd/groupadd macros
4c73bc69 1034# Author: Elan Ruusamäe <glen@pld-linux.org>
90627280
ER
1035#
1036# Usage:
1037# %useradd [-P package] [-u uid] [-d home_dir] [-s shell] [-c comment]
1038# [-g initial_group] [-G group[,...]] login
1039#
1040# -u uid. REQUIRED
1041# -g gid/group. REQUIRED
1042# -s defaults to /bin/false
1043# -d defaults to /usr/share/empty
1044# -c No default
1045# -r is accepted but ignored (it's always set)
6bd4c218 1046# -k skeleton dir. defaults to /usr/share/empty
90627280
ER
1047# rpm specific flags
1048# -P package name. defaults to %{name}
1049#
90627280 1050%useradd(c:d:e:f:g:G:Mmk:op:s:u:rP:) \
9ba02ba9
ER
1051%{!-u:%{error:useradd: Required argument -u missing}} \
1052%{!-g:%{error:useradd: Required argument -g missing}} \
1053%{!?1:%{error:useradd: Required parameter login missing}} \
90627280
ER
1054if [ -n "`/bin/id -u %{expand:%{%{#}}} 2>/dev/null`" ]; then \
1055 if [ "`/bin/id -u %{expand:%{%{#}}}`" != "%{-u*}" ]; then \
1056 echo "Error: user %{expand:%{%{#}}} doesn't have uid=%{-u*}. Correct this before installing %{-P*}%{!?-P:%{name}}." 1>&2 \
1057 exit 1 \
1058 fi \
1059else \
1060 echo "Adding user %{expand:%{%{#}}} UID=%{-u*}." \
1061 /usr/sbin/useradd \\\
b5a7d552 1062 %{-m:-m -k %{-k*}%{!-k:/usr/share/empty}} \\\
90627280
ER
1063 -u %{-u*} \\\
1064 -r \\\
1065 -d %{-d*}%{!-d:/usr/share/empty} \\\
1066 -s %{-s*}%{!-s:/bin/false} \\\
840e7b00 1067 %{-c:-c "%(set -- %{-c*} %{*}; echo $1)"}\\\
90627280
ER
1068 -g %{-g*} \\\
1069 %{-M} \\\
1070 %{-G:-G %{-G*}} \\\
1aac682a 1071 %{expand:%{%{#}}} 1>&2 || exit $? \
bcf63b58 1072 [ ! -x /usr/sbin/nscd ] || /usr/sbin/nscd -i passwd || : \
90627280 1073fi;
611a25d5 1074# vim: "
90627280 1075
90627280
ER
1076# Usage:
1077# %groupadd [-P package] [-g gid] group
1078#
1079# -g gid. REQUIRED
1080#
1081# Sample:
1082# %groupadd -P %{name}-base -g %{gid} %{name}
1083
1084%groupadd(g:P:rfo) \
9ba02ba9
ER
1085%{!-g:%{error:groupadd: Required argument -g missing}} \
1086%{!?1:%{error:groupadd: Required parameter group missing}} \
637962e6 1087if /usr/bin/getgid %{1} > /dev/null 2>&1; then \
90627280
ER
1088 if [ "`/usr/bin/getgid %{1}`" != "%{-g*}" ]; then \
1089 echo "Error: group %{1} doesn't have gid=%{-g*}. Correct this before installing %{-P*}%{!?-P:%{name}}." 1>&2 \
1090 exit 1 \
1091 fi \
1092else \
1093 echo "Adding group %{1} GID=%{-g*}." \
1aac682a 1094 /usr/sbin/groupadd -g %{-g*} -r %{1} 1>&2 || exit $? \
bcf63b58 1095 [ ! -x /usr/sbin/nscd ] || /usr/sbin/nscd -i group || : \
90627280 1096fi;
7cb77741 1097
7c50f037 1098# webapp macros
4c73bc69 1099# Author: Elan Ruusamäe <glen@pld-linux.org>
35663282
ER
1100#
1101# The config is installed/removed inside trigger, this means that you can any
1102# time install apache1/apache/lighttpd package and the configuration file is
fe6c4bdd 1103# updated. if you don't need the config for various reason for specific
35663282
ER
1104# webserver, just remove the symlink from config directory using webapp
1105# program. the trigger will not recreate the symlink on upgrades. In other
1106# words the config is linked to webserver config directory on first install of
1107# PACKAGE or WEBSERVER.
1108#
7c50f037
ER
1109# Add package's webserver config to webserver webapps dir.
1110# Usage:
aea687a7 1111# %webapp_register [-f] WEBSERVER WEBAPP
35663282 1112#
aea687a7 1113%webapp_register(f) \
35663282 1114%{?debug:set -x; echo "webapp_register: %{name}-%{version}-%{release} 1:[$1]; 2:[$2]"} \
aea687a7 1115if [ -n "%{-f:1}" ] || [ "$1" = "1" ] && [ "$2" = "1" ]; then\
35663282
ER
1116 /usr/sbin/webapp register %1 %2\
1117fi\
694a8f2e 1118# reload webserver if the config symlink is there and skip reload if webserver is upgraded\
5d3a09a3 1119if [ -L /etc/%1/webapps.d/%(echo "%2" | tr '/' '-').conf ] && [ "$2" -lt "2" ]; then\
16897aea 1120 %{expand:%service -q %%1 reload}\
35663282
ER
1121fi\
1122%{nil}
1123
1124# Remove package's config from webserver webapps dir.
35663282 1125# Usage:
531c0efc
ER
1126# %webapp_register [-f] WEBSERVER WEBAPP
1127%webapp_unregister(f) \
35663282
ER
1128%{?debug:set -x; echo "webapp_unregister: %{name}-%{version}-%{release}: 1:[$1]; 2:[$2]"} \
1129# remove link if either of the packages are gone \
5d3a09a3 1130if [ -n "%{-f:1}" ] || [ "$1" = "0" ] || [ "$2" = "0" ] && [ -L /etc/%1/webapps.d/%(echo "%2" | tr '/' '-').conf ]; then \
df979130 1131 /usr/sbin/webapp unregister %1 %2\
16897aea 1132 %{expand:%service -q %%1 reload}\
35663282
ER
1133fi \
1134%{nil}
1135
462b26fa 1136# service macro.
4c73bc69 1137# Author: Elan Ruusamäe <glen@pld-linux.org>
462b26fa
ER
1138#
1139# calls usual service restart on package %post, but skips the restart if
1140# administrator has disabled automatic service restarts in either global
1141# /etc/sysconfig/rpm or per service /etc/sysconfig/SERVICE file.
1142#
462b26fa 1143# Usage:
7377b5ca 1144# %service [-q] [-n] SERVICE ACTION ["SERVICE NICE DESCRIPTION"]
462b26fa 1145#
a0bbe604 1146# -q be silent when service isn't started (for scriplets restaring other package's services)
7377b5ca 1147# -n NOOP mode, do not actually restart service
462b26fa 1148#
7377b5ca
ER
1149# Requirements:
1150# BuildRequires: rpmbuild(macros) >= 1.268
1151# Requires: rc-scripts
1152# -n option:
1153# BuildRequires: rpmbuild(macros) >= 1.450
1154%service(qn) {{%(export noop=%{-n:1} quiet=%{-q:1}; /usr/lib/rpm/service_generator.sh %{*}) };}
6aedae62
ER
1155
1156
f9aa75bf
ER
1157# Java macros. based on jpackage macros.java
1158#
1159# Root directory where all Java VMs/SDK/JREs are installed.
2d4659a1 1160%_jvmdir %{_libdir}/jvm
f9aa75bf
ER
1161
1162# Root directory where all Java VMs/SDK/JREs expose their jars
2d4659a1 1163%_jvmjardir %{_libdir}/jvm-exports
f9aa75bf
ER
1164
1165# Root directory for all Java VM/SDK/JRE's private things.
1166%_jvmprivdir %{_libdir}/jvm-private
1167
1168# Root directory for all architecture dependent parts of Java VM/SDK/JRE's
2d4659a1 1169%_jvmlibdir %{_libdir}/jvm
f9aa75bf
ER
1170
1171# Root directory for all architecture independent parts of Java VM/SDK/JRE's
1172%_jvmdatadir %{_datadir}/jvm
1173
1174# Root directory for all configurations parts of Java VM/SDK/JRE's
1175%_jvmsysconfdir %{_sysconfdir}/jvm
1176
1177# Root directory for all common architecture dependent parts of Java VM/SDK/JRE's
f5ed4276 1178%_jvmcommonlibdir %{_libdir}/jvm-common
f9aa75bf
ER
1179
1180# Root directory for all common architecture independent parts of Java VM/SDK/JRE's
f5ed4276 1181%_jvmcommondatadir %{_datadir}/jvm-common
f9aa75bf
ER
1182
1183# Root directory for all common configurations parts of Java VM/SDK/JRE's
f5ed4276 1184%_jvmcommonsysconfdir %{_sysconfdir}/jvm-common
f9aa75bf
ER
1185
1186# Directory where arch-specific (JNI) version-independent jars are installed.
2d4659a1 1187%_jnidir %{_libdir}/java
f9aa75bf 1188
c94807f3 1189%java_home %{expand:%%global java_home %([ -f %{_javadir}-utils/java-functions ] || { echo ERROR; exit 0; }; unset JAVA_HOME; . %{_javadir}-utils/java-functions; set_jvm; echo ${JAVA_HOME:-ERROR})}%java_home
6aedae62 1190
a9254650 1191%ant JAVA_HOME=%{java_home} CLASSPATH=$CLASSPATH ant
fe6c4bdd 1192%jar %{java_home}/bin/jar
c94807f3 1193%java %{expand:%%global java %([ -f %{_javadir}-utils/java-functions ] || { echo ERROR; exit 0; }; unset JAVACMD; . %{_javadir}-utils/java-functions; set_javacmd; echo $JAVACMD)}%java
fe6c4bdd
ER
1194%javac %{java_home}/bin/javac
1195%javadoc %{java_home}/bin/javadoc
6aedae62 1196
fe6c4bdd 1197%add_jvm_extension JAVA_LIBDIR=%{buildroot}/%{_javadir} %{_bindir}/jvmjar -l
6aedae62
ER
1198
1199%jpackage_script() \
3ca65b87
ER
1200install -d $RPM_BUILD_ROOT%{_bindir}\
1201cat > $RPM_BUILD_ROOT%{_bindir}/%5 << 'EOF' \
6aedae62
ER
1202#!/bin/sh\
1203#\
1204# %{name} script\
1205# JPackage Project <http://www.jpackage.org/>\
1206\
1207# Source functions library\
1208. %{_javadir}-utils/java-functions\
1209\
1210# Source system prefs\
3ca65b87 1211if [ -f %{_sysconfdir}/java/%{name}.conf ]; then\
fe6c4bdd 1212 . %{_sysconfdir}/java/%{name}.conf\
6aedae62
ER
1213fi\
1214\
1215# Source user prefs\
3ca65b87
ER
1216if [ -f $HOME/.%{name}rc ]; then\
1217 . $HOME/.%{name}rc\
6aedae62
ER
1218fi\
1219\
1220# Configuration\
1221MAIN_CLASS=%1\
1222BASE_FLAGS=%2\
1223BASE_OPTIONS=%3\
3ca65b87 1224BASE_JARS="%(echo %4 | tr ':' ' ')"\
6aedae62
ER
1225\
1226# Set parameters\
1227set_jvm\
3ca65b87
ER
1228set_classpath $BASE_JARS\
1229set_flags $BASE_FLAGS\
1230set_options $BASE_OPTIONS\
6aedae62
ER
1231\
1232# Let's start\
3ca65b87 1233run "$@"\
6aedae62
ER
1234EOF
1235
06f11871
ER
1236# jpackage 1.7
1237# Directory for maven depmaps
1238#
1239%_mavendepmapdir /etc/maven
1240%_mavendepmapfragdir /etc/maven/fragments
1241
1242#
1243# add_to_depmap adds an entry to the depmap. The arguments are:
1244#
1245# %1 the original groupid
1246# %2 the original artifact id
1247# %3 the version
1248# %4 the new groupid
1249# %5 the new artifactid
1250#
1251
1252%add_to_maven_depmap() \
1253install -dm 755 $RPM_BUILD_ROOT/%{_mavendepmapfragdir}\
1254cat >>$RPM_BUILD_ROOT/%{_mavendepmapfragdir}/%{name}<< EOF\
1255<dependency>\
1256 <maven>\
1257 <groupId>%1</groupId>\
1258 <artifactId>%2</artifactId>\
1259 <version>%3</version>\
1260 </maven>\
1261 <jpp>\
1262 <groupId>%4</groupId>\
1263 <artifactId>%5</artifactId>\
1264 <version>%3</version>\
1265 </jpp>\
1266</dependency>\
1267\
1268EOF\
1269%{nil}
1270
1271#==============================================================================
1272#
1273# update_maven_depmap updates the main maven depmap
1274#
1275%update_maven_depmap() \
1276echo -e "<dependencies>\\n" > %{_mavendepmapdir}/maven2-depmap.xml\
1277if [ -d %{_mavendepmapfragdir} ] && [ -n "`find %{_mavendepmapfragdir} -type f`" ]; then\
1278cat %{_mavendepmapfragdir}/* >> %{_mavendepmapdir}/maven2-depmap.xml\
1279fi\
1280echo -e "</dependencies>\\n" >> %{_mavendepmapdir}/maven2-depmap.xml
1281
1282
59d3ebe9 1283# PEAR install macros
4c73bc69 1284# Author: Elan Ruusamäe <glen@pld-linux.org>
dfce8b19
ER
1285#
1286# Usage:
f7ecf326 1287# %%pear_package_setup ...
dfce8b19 1288#
59d3ebe9 1289# -a # - also unpack SOURCE#. for PEAR bootstrapping
dfce8b19 1290# -n FMT - create builddir with FMT, instead of default %%{_pearname}-%%{version}
59d3ebe9 1291# -z - unpack pear package and let pear use package.xml (not tarball) for install. for PEAR bootstrapping
f7ecf326
ER
1292# -D - pass -D to %setup (so the build dir is not removed)
1293# -c - register channel from local channel.xml file
dfce8b19
ER
1294#
1295# unpack PEAR package to %%{_builddir}/FMT. package is extracted with already
1296# destination hierarchy. you should copy the tree to buildroot after
1297# patching/reorganizing with %%pear_package_install.
1298#
1299# additionally BUILDROOT is stripped from files and files are converted to UNIX
1300# line endings.
1301#
1302# the pear install process output is recorded to install.log, you should put it
8763f51e 1303# to %%doc for later debug or just for information.
dfce8b19
ER
1304#
1305# additionally additional-packages.txt is produced if it was detected that the
1306# package has optional dependencies. the file format is suitable of displaying
1307# in %%post of a package. you should put this file to %%doc. noautocompressdoc is
1308# automatically added for this file.
59d3ebe9
ER
1309
1310
1311# records install.log and transforms PEAR names to PLD Linux rpm package names.
1312%__pear_install_log \
1313tee install.log \
1314# make post message of optional packages \
f64d1bb2 1315grep 'can optionally use' install.log | sed -e 's,package "pear/,package "php-pear-,g;s,^pear/,php-pear-,;s,^pear/,php-pear-,;s,^channel://.*/,,' > optional-packages.txt \
59d3ebe9
ER
1316if [ -s optional-packages.txt ]; then \
1317 awk -F'"' '/use package/{print $2}' optional-packages.txt | sed -e "s,_,/,g;s,php-pear-, 'pear(,;s,$,.*)'," | tr -d '\\\n' > _noautoreq \
1318else \
1319 rm -f optional-packages.txt \
1320fi \
1321%{nil}
1322
1323# command invoking pear cli
1324%__pear /usr/bin/pear
1325
67a089ff 1326%pear_install(a:n:zD) \
59d3ebe9 1327%__pear \\\
f7ecf326 1328 -c %{builddir}/pearrc \\\
dfce8b19 1329 -d doc_dir=/docs \\\
f7ecf326
ER
1330 -d temp_dir=/tmp \\\
1331 -d php_dir=%{-c:%{builddir}/}%{php_pear_dir} \\\
dfce8b19
ER
1332 -d bin_dir=%{_bindir} \\\
1333 -d data_dir=%{php_pear_dir}/data \\\
1334 -d test_dir=%{php_pear_dir}/tests \\\
1335 install \\\
59d3ebe9 1336 --packagingroot=%{builddir} \\\
dfce8b19
ER
1337 --offline \\\
1338 --nodeps \\\
1339 %{-f:--force} \\\
67a089ff 1340 %{!-z:%{S:%{-a*}%{!-a:0}}}%{-z:$_P} > .install.log || { c=$?; cat .install.log; exit $c; }; \
b872fad7 1341 %{-c:cp -a %{builddir}/%{builddir}/%{php_pear_dir} %{builddir}/%(dirname %{php_pear_dir}); rm -rf %{builddir}/%{builddir}; } \
67a089ff
ER
1342%{nil}
1343
1344# The main macro.
1345# using this macro will append optional-packages.txt to the nocompressdoc list
1346# as it's displayed to user after package install. and adding additional gzip
1347# dep is just waste ;)
f7ecf326 1348%pear_package_setup(a:n:zDc:) \
67a089ff
ER
1349%define srcdir %{-n*}%{!-n:%{_pearname}-%{version}} \
1350%define builddir %{_builddir}/%{srcdir} \
1351%setup -q -c -T %{-D:-D} -n %{srcdir} \
1352%{-z:tar zxf %{S:0}; %{-a:tar zxf %{S:%{-a*}}}} \
1353%{-z:_P=package2.xml; [ -f $_P ] || _P=package.xml; _N=%{srcdir}; mv $_P $_N; cd $_N} \
f7ecf326 1354%{-c:%{__pear} -c pearrc config-set php_dir %{builddir}/%{php_pear_dir}; %__pear -c %{builddir}/pearrc channel-add %{-c*}} \
67a089ff 1355%pear_install \
59d3ebe9
ER
1356%{-z:cd ..} \
1357cat %{-z:$_N/}.install.log | %__pear_install_log \
1358\
dfce8b19 1359# undos sources \
2a80e4cf 1360find -type f -print0 | xargs -0 sed -i -e 's,\\r$,,' \
dfce8b19
ER
1361%{!?_noautocompressdoc:%global _noautocompressdoc %{nil}}%{expand:%%global _noautocompressdoc %{_noautocompressdoc} optional-packages.txt} \
1362%{!?_noautoprov:%global _noautoprov %{nil}}%{expand:%%global _noautoprov %{_noautoprov} 'pear(tests/.*)'} \
1363%{nil}
1364
7bef60e8 1365# Copies exctracted PEAR package structure and PEAR registry to buildroot.
4c73bc69 1366# Author: Elan Ruusamäe <glen@pld-linux.org>
dfce8b19
ER
1367%pear_package_install() \
1368cp -a ./%{php_pear_dir}/{.registry,*} $RPM_BUILD_ROOT%{php_pear_dir} \
1369find $RPM_BUILD_ROOT%{php_pear_dir} '(' -name '*~' -o -name '*.orig' ')' | xargs -r rm -v \
1370# help the developer out a little: \
1371if [ -f _noautoreq ]; then \
1372 echo "AutoReqdep detected:" \
1373 echo "_noautoreq $(cat _noautoreq)" \
1374fi \
1375%{nil}
1376
0d5dd00c
ER
1377
1378# Register OpenLDAP schema.
4c73bc69 1379# Author: Elan Ruusamäe <glen@pld-linux.org>
0d5dd00c
ER
1380#
1381# Usage:
1382# %%openldap_schema_register [-d core,nis] %{schemadir}/horde.schema
1383#
1384# -d specify dependant schemas, separated by comma
1385#
1386%openldap_schema_register(d:) \
1387for schema in %*; do \
1388 if ! grep -q "$schema" /etc/openldap/slapd.conf; then \
1389 %{__sed} -i -e " \
1390 /^include.*local.schema/{ \
1391 iinclude\\t $schema\
1392 } \
1393 " /etc/openldap/slapd.conf \
1394 fi \
1395done \
1396# enable dependant schemas \
1397if [ "%{-d*}" ]; then \
1398 %{__sed} -i -e ' \
1399 /^#include.*\\(%(echo '%{-d*}' | %{__sed} -e 's/,/\\\\|/g')\\)\\.schema/{ \
1400 s/^#// \
1401 }' /etc/openldap/slapd.conf \
1402fi \
1403%{nil}
1404
1405# Unregister OpenLDAP schema.
4c73bc69 1406# Author: Elan Ruusamäe <glen@pld-linux.org>
0d5dd00c
ER
1407#
1408# Usage:
1409# %%openldap_schema_unregister %{schemadir}/horde.schema
1410#
1411%openldap_schema_unregister() \
1412for schema in %*; do \
1413 if grep -q "$schema" /etc/openldap/slapd.conf; then \
1414 %{__sed} -i -e " \
1415 /^include.*$(echo "$schema" | %{__sed} -e 's,/,\\\\/,g')/d \
1416 # for symmetry it would be nice if we disable enabled schemas in post, \
1417 # but we really can not do that, it would break something else. \
1418 " /etc/openldap/slapd.conf \
1419 fi \
1420done \
1421%{nil}
1422
b0bc2936 1423%env_update [ ! -x /sbin/env-update ] || /sbin/env-update -u || :
d834e0a1 1424
dcc6baf7 1425
1426# Build modules for kernels 2.6
1427# Author: Przemyslaw Iskra <sparky@pld-linux.org>
1428#
1429# Usage:
aa559e46 1430# %build_kernel_modules -m <modules> -C <directory>
dcc6baf7 1431#
1432# remember that proper Makefile is still required
1433# Options:
990bd03f 1434# -m <modules> (required) -- comma-separated list of modules to save,
dcc6baf7 1435# without .ko extension, may be placed in subdirectory
aa559e46 1436# -C <directory> -- change to <directory> before doing anything
dcc6baf7 1437# -p <arg>, -P <arg> -- arguments passeed to make scripts
5a81d83e 1438# -c -- do not execute make clean
dcc6baf7 1439# <additional arguments> -- all additional arguments will be passed to
1440# make modules
1441#
1442# Additional patching supported via here document. Try:
1443# %build_kernel_modules -m module <<'EOF'
1444# your patch script here
1445# EOF
1446# Don't use it unless patching depends on config options.
1447
1448# Developer note: don't touch it unless you know how to handle '\'.
1449# - \ in script expands to nothing
1450# - \\\ in script expands to \
566398b4 1451# - \\\ inside definition expands to nothing
dcc6baf7 1452# - \\\\\\\ inside definition expands to \
1453# - in last line \ has to touch arguments so arguments passing
1454# in new lines (using \) will be supported
1455
5a81d83e 1456%build_kernel_modules(p:P:m:C:c) \
dcc6baf7 1457%{!?-m:%{error:%{0}: Required module name/list missing} exit 1} \
1458 \
1459%define Opts \\\\\\\
1460%if "%{_target_base_arch}" != "%{_arch}" \\\
1461 %if "%{_arch}" == "x86_64" && "%{_target_base_arch}" == "i386" \\\
88608ef7 1462 CC="%{kgcc}" ARCH=%{_target_base_arch} \\\
dcc6baf7 1463 %else \\\
1464 ARCH=%{_target_base_arch} CROSS_COMPILE=%{_target_cpu}-pld-linux- \\\
1465 %endif \\\
1466%else \\\
88608ef7 1467 CC="%{kgcc}" \\\
dcc6baf7 1468%endif \
88608ef7 1469%define MakeOpts HOSTCC="%{kgcc}" SYSSRC=%{_kernelsrcdir} SYSOUT=$PWD/o \\\\\\\
dcc6baf7 1470 O=$PWD/o %{?with_verbose:V=1} %{Opts} \
1471 \
e364bc26 1472%{?-C:cd %{-C*}} \
dcc6baf7 1473compile() { \
ba9de9b2
ER
1474 local L="<" PATCH_SH; \
1475 [[ '%{*}' != *$L$L* ]] || PATCH_SH="set -x -e;$(cat)" \
dcc6baf7 1476 set -e -x \
730239f9 1477 local cfgs='%{?with_dist_kernel:%{?with_smp: smp}%{?with_up: up}}%{!?with_dist_kernel: nondist}' \
dcc6baf7 1478 \
730239f9 1479for cfg in ${cfgs:-dist}; do \
dcc6baf7 1480 [ -r "%{_kernelsrcdir}/config-$cfg" ] || exit 1 \
1481 \
c546f6fb 1482 rm -rf o \
68cfe9d9 1483 install -d o/include/linux o/arch/powerpc/lib \
dcc6baf7 1484 ln -sf %{_kernelsrcdir}/config-$cfg o/.config \
1485 ln -sf %{_kernelsrcdir}/Module.symvers-$cfg o/Module.symvers \
1486 ln -sf %{_kernelsrcdir}/include/linux/autoconf-$cfg.h o/include/linux/autoconf.h \
1487 \
1488 set +x \
1489 [ -z "$PATCH_SH" ] || echo "$PATCH_SH" | %__spec_build_shell \
1490 set -x \
1491 \
c768535c 1492 %if %{with dist_kernel} || %(test -f %{_kernelsrcdir}/scripts/bin2c ; echo $?) \
dcc6baf7 1493 %{__make} -j1 -C %{_kernelsrcdir} prepare scripts \\\
1494 %{-p*} %{-P*} \\\
1495 %{MakeOpts} \
1496 %else \
1497 install -d o/include/config \
1498 touch o/include/config/MARKER \
588f1b0b 1499 ln -sf %{_kernelsrcdir}/include/config/auto-$cfg.conf o/include/config/auto.conf \
dcc6baf7 1500 ln -sf %{_kernelsrcdir}/scripts o/scripts \
1501 %endif \
1502 \
5a81d83e 1503 %{!?-c:%{__make} -C %{_kernelsrcdir} clean \\\
dcc6baf7 1504 RCS_FIND_IGNORE="-name '*.ko' -o" \\\
f635907b 1505 ${1+"$@"} \\\
5a81d83e 1506 M=$PWD %{MakeOpts}} \
f635907b 1507 \
dcc6baf7 1508 %{__make} -C %{_kernelsrcdir} modules \\\
1509 ${1+"$@"} \\\
1510 M=$PWD %{MakeOpts} \
1511 \
1512 for MODULE in {%{-m*},}; do \
1513 [ -z "${MODULE}" ] || mv ${MODULE}{,-$cfg}.ko \
1514 done \
1515done \
aa559e46 1516%{?-C:cd -} \
dcc6baf7 1517} \
1518compile %{*}\
1519%{nil}
1520
1521
1522# Install kernel modules built by %build_kernel_modules
1523# Author: Przemyslaw Iskra <sparky@pld-linux.org>
1524#
1525# Usage:
1526# %install_kernel_modules -m <modules> -d <directory>
1527#
1528# Options:
990bd03f 1529# -m <modules> (required) -- comma-separated list of modules to install,
dcc6baf7 1530# without .ko extension, may be placed in subdirectory
1531# -d <directory> (required) -- in what subdirectory modules should be
1532# installed (eg. misc, kernel/drivers/net)
1533# -s <suffix> -- suffix to use when installing modules, useful when module
1534# with same name exists in kernel already
1535# -n <file> -- name of modprobe config file to use (without .conf extension)
00395cf1 1536# for defining aliases, only useful with -s
dcc6baf7 1537
1538%install_kernel_modules(m:d:s:n:) \
1539%{!?-m:%{error:%{0}: Required module name (-m) missing}exit 1} \
1540%{!?-d:%{error:%{0}: Required module directory missing}exit 1} \
1541%{?-n:%{!?-s:%{error:%{0}: Modprobe .conf file requires module suffix}exit 1}} \
1542 \
1543%define KernelD $RPM_BUILD_ROOT/lib/modules/%{_kernel_ver} \
1544%define ModprobeD $RPM_BUILD_ROOT%{_sysconfdir}/modprobe.d/%{_kernel_ver} \
412786d1 1545 \
b279feda 1546__install_kernel_modules() { \
730239f9 1547local cfgs='%{?with_dist_kernel:%{?with_smp: smp}%{?with_up: up}}%{!?with_dist_kernel: nondist}' \
dcc6baf7 1548 \
1549for MODULE in {%{-m*},}; do \
1550 [ -n "${MODULE}" ] || continue \
730239f9
ER
1551 for cfg in ${cfgs:-dist}; do \
1552 [ "$cfg" = smp ] && suf=smp || suf= \
1553 MNAME=${MODULE##*/} \
1554 install -D ${MODULE}-$cfg.ko \\\
1555 %{KernelD}$suf/%{-d*}/${MNAME}%{-s:-%{-s*}}.ko \
b9460afb 1556 %{?-s:install -d %{ModprobeD}$suf \
730239f9
ER
1557 echo "alias ${MNAME} ${MNAME}-%{-s*}" \\\
1558 >> %{ModprobeD}$suf/%{-n*}.conf} \
1559 done \
dcc6baf7 1560done \
b279feda 1561} \
1562__install_kernel_modules \
dcc6baf7 1563%{nil}
1564
fa65356c 1565# patchset macros
4c73bc69 1566# Author: Elan Ruusamäe <glen@pld-linux.org>
fa65356c
ER
1567#
1568# Usage:
1569# %patchset_source -f <seq(1) format> <start> [<end>]
1570# %patchset_patch <start> [<end>]
1571#
1572# If <end> is omited, it is assumed to be <start>.
1573#
1574# For example in preamble:
1575# %patchset_source -f ftp://ftp.vim.org/pub/editors/vim/patches/7.0/7.0.%03g 33 44
1576# and in %prep:
1577# %patchset_patch 33 44
1578
1579# generate SourceX urls from range START STOP
1580# Format can be SINGLE format char of %e, %f, %g, see seq(1)
1581# The sources start from 10000
e91610db 1582%patchset_source(f:b:) %(
44f733ef 1583 base=%{-b*}%{!-b*:10000};
962f9ecf
ER
1584 start=$(expr $base + %1);
1585 end=$(expr $base + %{?2}%{!?2:%{1}});
e91610db
ER
1586 # we need to call seq twice as it doesn't allow two formats
1587 seq -f 'Patch%g:' $start $end > %{tmpdir}/__ps1;
1588 seq -f '%{-f*}' %1 %{?2}%{!?2:%{1}} > %{tmpdir}/__ps2;
1589 paste %{tmpdir}/__ps{1,2};
1590 rm -f %{tmpdir}/__ps{1,2};
962f9ecf
ER
1591) \
1592%{nil}
fa65356c
ER
1593
1594# apply sources from %patchset_source
1595# -p specify -pX for %patch line
1596# -b base offset: defaults to 10000
1597%patchset_patch(f:p:b:) %(
44f733ef 1598 base=%{-b*}%{!-b*:10000};
962f9ecf
ER
1599 start=$(expr $base + %1);
1600 end=$(expr $base + %{?2}%{!?2:%{1}});
e91610db
ER
1601 echo ": patchset_patch %1%{?2: to %2}";
1602 seq -f 'patch%g %{-p*:-p%{-p*}}' $start $end | sed -e s,^,%%,;
962f9ecf
ER
1603) \
1604%{nil}
fa65356c 1605
5730b44b 1606# browser plugins v2
4c73bc69 1607# Author: Elan Ruusamäe <glen@pld-linux.org>
5730b44b
ER
1608#
1609# Usage:
1610# %browser_plugins_add_browser <name> -p <plugindir>
1611#
1612# <name> (required) -- name of the browser. usually %{name}.
1613# -p <plugindir> (required) -- in what directory browser searches for its plugins.
02ebf70f
ER
1614# -b -- default blacklists
1615# -a <arch> override arch
5730b44b
ER
1616#
1617# Example:
1618# %browser_plugins_add_browser %{name} -p %{_firefoxdir}/plugins
1619
1620%_browserpluginsconfdir /etc/browser-plugins
5e19a4dc 1621%_browserpluginsdir %{_libdir}/browser-plugins
5730b44b
ER
1622%update_browser_plugins /usr/sbin/update-browser-plugins || :
1623
02ebf70f 1624%browser_plugins_add_browser(p:b:a:) \
9efd458e 1625 browser=%1.%{!-a:%{_target_base_arch}}%{-a*} \
5730b44b 1626 install -d $RPM_BUILD_ROOT%{_browserpluginsconfdir}/{blacklist,browsers}.d \
02ebf70f
ER
1627 ln -s %{-p*} $RPM_BUILD_ROOT%{_browserpluginsconfdir}/browsers.d/$browser \
1628 blacklist_file=$RPM_BUILD_ROOT%{_browserpluginsconfdir}/blacklist.d/$browser.blacklist \
5730b44b
ER
1629 echo '# This file format is shell globs at base dir of plugindir' > $blacklist_file \
1630 %{-b:cat >> $blacklist_file %{-b*}} \
1631%{nil}
1632
ad17b654
ER
1633# Helper for LUA.
1634# split string separated by space into quoted list
1635#
4c73bc69 1636# Author: Elan Ruusamäe <glen@pld-linux.org>
ad17b654
ER
1637#
1638# %__lua_split /bin/sh /bin/pdksh -> "/bin/sh", "/bin/pdksh"
1639%__lua_split() %(echo "%*" | awk '{for (i=1;i<=NF;i++) printf("\\"%%s\\"%%s", $i, i == NF ? "" : ", ")}')
1640
1641# adjust /etc/shells by adding and removing shells from there
4c73bc69 1642# Author: Elan Ruusamäe <glen@pld-linux.org>
ad17b654
ER
1643#
1644# Usage:
d9b789d9
ER
1645# %post -p <lua>
1646# %lua_add_etc_shells /bin/sh /bin/pdksh
ad17b654 1647#
d9b789d9
ER
1648# %preun -p <lua>
1649# if arg[2] == 0 then
1650# %lua_remove_etc_shells /bin/bash /bin/rbash
1651# end
7377b5ca
ER
1652#
1653# Requirements:
d9b789d9
ER
1654# BuildRequires: rpmbuild(macros) >= 1.462
1655#
ad17b654 1656
d9b789d9 1657%lua_add_etc_shells() \
ad17b654
ER
1658t = {}\
1659f = io.open("/etc/shells", "r")\
1660if f then\
1661 for l in f:lines() do t[l]=l; end\
1662 f:close()\
1663end\
1664for _, s in ipairs({%{expand:%%__lua_split %*}}) do\
1665 if not t[s] then\
b8c0bc18 1666 print("Adding "..s.." to /etc/shells")\
ad17b654
ER
1667 f = io.open("/etc/shells", "a"); f:write(s.."\\n"); f:close()\
1668 end\
1669end\
1670%{nil}
1671
d9b789d9
ER
1672%lua_remove_etc_shells() \
1673t = {}\
1674f = io.open("/etc/shells", "r")\
1675if f then\
1676 for l in f:lines() do t[l]=l; end\
1677 f:close()\
1678end\
1679for _, l in pairs({%{expand:%%__lua_split %*}}) do\
1680 print("Removing "..l.." from /etc/shells")\
1681 t[l] = nil\
1682end\
1683s=""\
1684for _, l in pairs(t) do\
1685 s=s..l.."\\n"\
1686end\
1687io.open("/etc/shells", "w"):write(s)\
1688%{nil}
1689
1690# Backwards compat. Use of %lua_ prefixed macros is preferred as these are cleaner to read.
1691#
1692# Author: Elan Ruusamäe <glen@pld-linux.org>
1693#
1694# Usage:
1695# %post -p %add_etc_shells -p /bin/sh /bin/pdksh
1696# %preun -p %remove_etc_shells -p /bin/sh /bin/pdksh
1697#
1698# -p (optional) -- specifies that result is embeded %post script (prepends <lua> as first line)
1699#
1700# Requirements:
1701# BuildRequires: rpmbuild(macros) >= 1.429
1702#
1703%add_etc_shells(p) %{-p:<lua>}\
1704%{expand:%%lua_add_etc_shells %*}\
1705%{nil}
1706
ad17b654 1707%remove_etc_shells(p) %{-p:<lua>}\
b8c0bc18 1708%{-p:if arg[2] == 0 then}\
d9b789d9 1709%{expand:%%lua_remove_etc_shells %*}\
750e19f4 1710%{-p:end} \
ad17b654
ER
1711%{nil}
1712
75bd6249
ER
1713# Check syntax for Python files
1714#
1715# Author: Elan Ruusamäe <glen@pld-linux.org>
1716# Author: Arkadiusz Miśkiewicz <arekm@pld-linux.org>
1717#
1718# Usage:
1719# %py_lint src
1720#
1721# Requirements:
1722# BuildRequires: python
1723# BuildRequires: rpmbuild(macros) >= 1.469
1724
1725%py_lint() \
1726__py_lint() { \
1727find "$@" -type f -name '*.py' | python -c ' \
1728import sys \
1729import compiler \
1730\
1731err = 0\
1732for f in sys.stdin: \
1733 fd = open(f.strip()) \
1734 c = fd.read() \
1735 fd.close() \
1736 try: \
1737 compiler.parse(c) \
1738 except SyntaxError, e: \
1739 print "py_lint: %s: %s" % (f.strip(), e) \
1740 err = err + 1\
1741\
1742if err: \
1743 print >> sys.stderr, "\\npy_lint: ERROR: Syntax errors in %d files.\\n" % err \
1744 sys.exit(1) \
1745else: \
1746 print >> sys.stderr, "py_lint: Found no syntax errors." \
1747' \
1748}; __py_lint %* \
1749%{nil}
1750
f602e4a0 1751# Undos files
1752#
1753# Author: Paweł Zuzelski <pawelz@pld-linux.org>
1754#
1755# Usage:
1756# %undos list_of_files
1757#
1758# Requirements:
1759# BuildRequires: sed >= 4.0
1760# BuildRequires: rpmbuild(macros) >= 1.533
1761
1762%undos \
1763%{__sed} -i -e 's,\\r$,,'
1764
f51bfb2f 1765# vim:ts=4 sw=4 noet ft=spec
This page took 0.53289 seconds and 4 git commands to generate.